// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('sablono.core');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('goog.string');
goog.require('sablono.util');
goog.require('sablono.interpreter');
goog.require('goog.dom');
goog.require('cljsjs.react');
/**
 * Add an optional attribute argument to a function that returns a element vector.
 */
sablono.core.wrap_attrs = (function sablono$core$wrap_attrs(func){
return (function() { 
var G__25724__delegate = function (args){
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,args))){
var vec__25723 = cljs.core.apply.call(null,func,cljs.core.rest.call(null,args));
var tag = cljs.core.nth.call(null,vec__25723,(0),null);
var body = cljs.core.nthnext.call(null,vec__25723,(1));
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,body))){
return cljs.core.apply.call(null,cljs.core.vector,tag,cljs.core.merge.call(null,cljs.core.first.call(null,body),cljs.core.first.call(null,args)),cljs.core.rest.call(null,body));
} else {
return cljs.core.apply.call(null,cljs.core.vector,tag,cljs.core.first.call(null,args),body);
}
} else {
return cljs.core.apply.call(null,func,args);
}
};
var G__25724 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__25725__i = 0, G__25725__a = new Array(arguments.length -  0);
while (G__25725__i < G__25725__a.length) {G__25725__a[G__25725__i] = arguments[G__25725__i + 0]; ++G__25725__i;}
  args = new cljs.core.IndexedSeq(G__25725__a,0);
} 
return G__25724__delegate.call(this,args);};
G__25724.cljs$lang$maxFixedArity = 0;
G__25724.cljs$lang$applyTo = (function (arglist__25726){
var args = cljs.core.seq(arglist__25726);
return G__25724__delegate(args);
});
G__25724.cljs$core$IFn$_invoke$arity$variadic = G__25724__delegate;
return G__25724;
})()
;
});
sablono.core.update_arglists = (function sablono$core$update_arglists(arglists){
var iter__17221__auto__ = (function sablono$core$update_arglists_$_iter__25731(s__25732){
return (new cljs.core.LazySeq(null,(function (){
var s__25732__$1 = s__25732;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__25732__$1);
if(temp__4425__auto__){
var s__25732__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__25732__$2)){
var c__17219__auto__ = cljs.core.chunk_first.call(null,s__25732__$2);
var size__17220__auto__ = cljs.core.count.call(null,c__17219__auto__);
var b__25734 = cljs.core.chunk_buffer.call(null,size__17220__auto__);
if((function (){var i__25733 = (0);
while(true){
if((i__25733 < size__17220__auto__)){
var args = cljs.core._nth.call(null,c__17219__auto__,i__25733);
cljs.core.chunk_append.call(null,b__25734,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)));

var G__25735 = (i__25733 + (1));
i__25733 = G__25735;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25734),sablono$core$update_arglists_$_iter__25731.call(null,cljs.core.chunk_rest.call(null,s__25732__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25734),null);
}
} else {
var args = cljs.core.first.call(null,s__25732__$2);
return cljs.core.cons.call(null,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)),sablono$core$update_arglists_$_iter__25731.call(null,cljs.core.rest.call(null,s__25732__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__17221__auto__.call(null,arglists);
});
/**
 * Render `element` as HTML string.
 */
sablono.core.render = (function sablono$core$render(element){
if(cljs.core.truth_(element)){
return React.renderToString(element);
} else {
return null;
}
});
/**
 * Render `element` as HTML string, without React internal attributes.
 */
sablono.core.render_static = (function sablono$core$render_static(element){
if(cljs.core.truth_(element)){
return React.renderToStaticMarkup(element);
} else {
return null;
}
});
/**
 * Include a list of external stylesheet files.
 */
sablono.core.include_css = (function sablono$core$include_css(var_args){
var args__17514__auto__ = [];
var len__17507__auto___25741 = arguments.length;
var i__17508__auto___25742 = (0);
while(true){
if((i__17508__auto___25742 < len__17507__auto___25741)){
args__17514__auto__.push((arguments[i__17508__auto___25742]));

var G__25743 = (i__17508__auto___25742 + (1));
i__17508__auto___25742 = G__25743;
continue;
} else {
}
break;
}

var argseq__17515__auto__ = ((((0) < args__17514__auto__.length))?(new cljs.core.IndexedSeq(args__17514__auto__.slice((0)),(0))):null);
return sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic(argseq__17515__auto__);
});

sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic = (function (styles){
var iter__17221__auto__ = (function sablono$core$iter__25737(s__25738){
return (new cljs.core.LazySeq(null,(function (){
var s__25738__$1 = s__25738;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__25738__$1);
if(temp__4425__auto__){
var s__25738__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__25738__$2)){
var c__17219__auto__ = cljs.core.chunk_first.call(null,s__25738__$2);
var size__17220__auto__ = cljs.core.count.call(null,c__17219__auto__);
var b__25740 = cljs.core.chunk_buffer.call(null,size__17220__auto__);
if((function (){var i__25739 = (0);
while(true){
if((i__25739 < size__17220__auto__)){
var style = cljs.core._nth.call(null,c__17219__auto__,i__25739);
cljs.core.chunk_append.call(null,b__25740,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null));

var G__25744 = (i__25739 + (1));
i__25739 = G__25744;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25740),sablono$core$iter__25737.call(null,cljs.core.chunk_rest.call(null,s__25738__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25740),null);
}
} else {
var style = cljs.core.first.call(null,s__25738__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null),sablono$core$iter__25737.call(null,cljs.core.rest.call(null,s__25738__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__17221__auto__.call(null,styles);
});

sablono.core.include_css.cljs$lang$maxFixedArity = (0);

sablono.core.include_css.cljs$lang$applyTo = (function (seq25736){
return sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq25736));
});
/**
 * Include the JavaScript library at `src`.
 */
sablono.core.include_js = (function sablono$core$include_js(src){
return goog.dom.appendChild(goog.dom.getDocument().body,goog.dom.createDom("script",{"src": src}));
});
/**
 * Include Facebook's React JavaScript library.
 */
sablono.core.include_react = (function sablono$core$include_react(){
return sablono.core.include_js.call(null,"http://fb.me/react-0.12.2.js");
});
/**
 * Wraps some content in a HTML hyperlink with the supplied URL.
 */
sablono.core.link_to25745 = (function sablono$core$link_to25745(var_args){
var args__17514__auto__ = [];
var len__17507__auto___25748 = arguments.length;
var i__17508__auto___25749 = (0);
while(true){
if((i__17508__auto___25749 < len__17507__auto___25748)){
args__17514__auto__.push((arguments[i__17508__auto___25749]));

var G__25750 = (i__17508__auto___25749 + (1));
i__17508__auto___25749 = G__25750;
continue;
} else {
}
break;
}

var argseq__17515__auto__ = ((((1) < args__17514__auto__.length))?(new cljs.core.IndexedSeq(args__17514__auto__.slice((1)),(0))):null);
return sablono.core.link_to25745.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__17515__auto__);
});

sablono.core.link_to25745.cljs$core$IFn$_invoke$arity$variadic = (function (url,content){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,url)], null),content], null);
});

sablono.core.link_to25745.cljs$lang$maxFixedArity = (1);

sablono.core.link_to25745.cljs$lang$applyTo = (function (seq25746){
var G__25747 = cljs.core.first.call(null,seq25746);
var seq25746__$1 = cljs.core.next.call(null,seq25746);
return sablono.core.link_to25745.cljs$core$IFn$_invoke$arity$variadic(G__25747,seq25746__$1);
});

sablono.core.link_to = sablono.core.wrap_attrs.call(null,sablono.core.link_to25745);
/**
 * Wraps some content in a HTML hyperlink with the supplied e-mail
 *   address. If no content provided use the e-mail address as content.
 */
sablono.core.mail_to25751 = (function sablono$core$mail_to25751(var_args){
var args__17514__auto__ = [];
var len__17507__auto___25756 = arguments.length;
var i__17508__auto___25757 = (0);
while(true){
if((i__17508__auto___25757 < len__17507__auto___25756)){
args__17514__auto__.push((arguments[i__17508__auto___25757]));

var G__25758 = (i__17508__auto___25757 + (1));
i__17508__auto___25757 = G__25758;
continue;
} else {
}
break;
}

var argseq__17515__auto__ = ((((1) < args__17514__auto__.length))?(new cljs.core.IndexedSeq(args__17514__auto__.slice((1)),(0))):null);
return sablono.core.mail_to25751.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__17515__auto__);
});

sablono.core.mail_to25751.cljs$core$IFn$_invoke$arity$variadic = (function (e_mail,p__25754){
var vec__25755 = p__25754;
var content = cljs.core.nth.call(null,vec__25755,(0),null);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),[cljs.core.str("mailto:"),cljs.core.str(e_mail)].join('')], null),(function (){var or__16449__auto__ = content;
if(cljs.core.truth_(or__16449__auto__)){
return or__16449__auto__;
} else {
return e_mail;
}
})()], null);
});

sablono.core.mail_to25751.cljs$lang$maxFixedArity = (1);

sablono.core.mail_to25751.cljs$lang$applyTo = (function (seq25752){
var G__25753 = cljs.core.first.call(null,seq25752);
var seq25752__$1 = cljs.core.next.call(null,seq25752);
return sablono.core.mail_to25751.cljs$core$IFn$_invoke$arity$variadic(G__25753,seq25752__$1);
});

sablono.core.mail_to = sablono.core.wrap_attrs.call(null,sablono.core.mail_to25751);
/**
 * Wrap a collection in an unordered list.
 */
sablono.core.unordered_list25759 = (function sablono$core$unordered_list25759(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ul","ul",-1349521403),(function (){var iter__17221__auto__ = (function sablono$core$unordered_list25759_$_iter__25764(s__25765){
return (new cljs.core.LazySeq(null,(function (){
var s__25765__$1 = s__25765;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__25765__$1);
if(temp__4425__auto__){
var s__25765__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__25765__$2)){
var c__17219__auto__ = cljs.core.chunk_first.call(null,s__25765__$2);
var size__17220__auto__ = cljs.core.count.call(null,c__17219__auto__);
var b__25767 = cljs.core.chunk_buffer.call(null,size__17220__auto__);
if((function (){var i__25766 = (0);
while(true){
if((i__25766 < size__17220__auto__)){
var x = cljs.core._nth.call(null,c__17219__auto__,i__25766);
cljs.core.chunk_append.call(null,b__25767,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__25768 = (i__25766 + (1));
i__25766 = G__25768;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25767),sablono$core$unordered_list25759_$_iter__25764.call(null,cljs.core.chunk_rest.call(null,s__25765__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25767),null);
}
} else {
var x = cljs.core.first.call(null,s__25765__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$unordered_list25759_$_iter__25764.call(null,cljs.core.rest.call(null,s__25765__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__17221__auto__.call(null,coll);
})()], null);
});

sablono.core.unordered_list = sablono.core.wrap_attrs.call(null,sablono.core.unordered_list25759);
/**
 * Wrap a collection in an ordered list.
 */
sablono.core.ordered_list25769 = (function sablono$core$ordered_list25769(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ol","ol",932524051),(function (){var iter__17221__auto__ = (function sablono$core$ordered_list25769_$_iter__25774(s__25775){
return (new cljs.core.LazySeq(null,(function (){
var s__25775__$1 = s__25775;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__25775__$1);
if(temp__4425__auto__){
var s__25775__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__25775__$2)){
var c__17219__auto__ = cljs.core.chunk_first.call(null,s__25775__$2);
var size__17220__auto__ = cljs.core.count.call(null,c__17219__auto__);
var b__25777 = cljs.core.chunk_buffer.call(null,size__17220__auto__);
if((function (){var i__25776 = (0);
while(true){
if((i__25776 < size__17220__auto__)){
var x = cljs.core._nth.call(null,c__17219__auto__,i__25776);
cljs.core.chunk_append.call(null,b__25777,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__25778 = (i__25776 + (1));
i__25776 = G__25778;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25777),sablono$core$ordered_list25769_$_iter__25774.call(null,cljs.core.chunk_rest.call(null,s__25775__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25777),null);
}
} else {
var x = cljs.core.first.call(null,s__25775__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$ordered_list25769_$_iter__25774.call(null,cljs.core.rest.call(null,s__25775__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__17221__auto__.call(null,coll);
})()], null);
});

sablono.core.ordered_list = sablono.core.wrap_attrs.call(null,sablono.core.ordered_list25769);
/**
 * Create an image element.
 */
sablono.core.image25779 = (function sablono$core$image25779(var_args){
var args25780 = [];
var len__17507__auto___25783 = arguments.length;
var i__17508__auto___25784 = (0);
while(true){
if((i__17508__auto___25784 < len__17507__auto___25783)){
args25780.push((arguments[i__17508__auto___25784]));

var G__25785 = (i__17508__auto___25784 + (1));
i__17508__auto___25784 = G__25785;
continue;
} else {
}
break;
}

var G__25782 = args25780.length;
switch (G__25782) {
case 1:
return sablono.core.image25779.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.image25779.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25780.length)].join('')));

}
});

sablono.core.image25779.cljs$core$IFn$_invoke$arity$1 = (function (src){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src)], null)], null);
});

sablono.core.image25779.cljs$core$IFn$_invoke$arity$2 = (function (src,alt){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src),new cljs.core.Keyword(null,"alt","alt",-3214426),alt], null)], null);
});

sablono.core.image25779.cljs$lang$maxFixedArity = 2;

sablono.core.image = sablono.core.wrap_attrs.call(null,sablono.core.image25779);
sablono.core._STAR_group_STAR_ = cljs.core.PersistentVector.EMPTY;
/**
 * Create a field name from the supplied argument the current field group.
 */
sablono.core.make_name = (function sablono$core$make_name(name){
return cljs.core.reduce.call(null,(function (p1__25787_SHARP_,p2__25788_SHARP_){
return [cljs.core.str(p1__25787_SHARP_),cljs.core.str("["),cljs.core.str(p2__25788_SHARP_),cljs.core.str("]")].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Create a field id from the supplied argument and current field group.
 */
sablono.core.make_id = (function sablono$core$make_id(name){
return cljs.core.reduce.call(null,(function (p1__25789_SHARP_,p2__25790_SHARP_){
return [cljs.core.str(p1__25789_SHARP_),cljs.core.str("-"),cljs.core.str(p2__25790_SHARP_)].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Creates a new <input> element.
 */
sablono.core.input_field_STAR_ = (function sablono$core$input_field_STAR_(type,name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),type,new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),value], null)], null);
});
/**
 * Creates a color input field.
 */
sablono.core.color_field25791 = (function sablono$core$color_field25791(var_args){
var args25792 = [];
var len__17507__auto___25859 = arguments.length;
var i__17508__auto___25860 = (0);
while(true){
if((i__17508__auto___25860 < len__17507__auto___25859)){
args25792.push((arguments[i__17508__auto___25860]));

var G__25861 = (i__17508__auto___25860 + (1));
i__17508__auto___25860 = G__25861;
continue;
} else {
}
break;
}

var G__25794 = args25792.length;
switch (G__25794) {
case 1:
return sablono.core.color_field25791.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.color_field25791.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25792.length)].join('')));

}
});

sablono.core.color_field25791.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.color_field25791.call(null,name__23007__auto__,null);
});

sablono.core.color_field25791.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"color","color",-1642760596,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.color_field25791.cljs$lang$maxFixedArity = 2;

sablono.core.color_field = sablono.core.wrap_attrs.call(null,sablono.core.color_field25791);

/**
 * Creates a date input field.
 */
sablono.core.date_field25795 = (function sablono$core$date_field25795(var_args){
var args25796 = [];
var len__17507__auto___25863 = arguments.length;
var i__17508__auto___25864 = (0);
while(true){
if((i__17508__auto___25864 < len__17507__auto___25863)){
args25796.push((arguments[i__17508__auto___25864]));

var G__25865 = (i__17508__auto___25864 + (1));
i__17508__auto___25864 = G__25865;
continue;
} else {
}
break;
}

var G__25798 = args25796.length;
switch (G__25798) {
case 1:
return sablono.core.date_field25795.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.date_field25795.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25796.length)].join('')));

}
});

sablono.core.date_field25795.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.date_field25795.call(null,name__23007__auto__,null);
});

sablono.core.date_field25795.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"date","date",177097065,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.date_field25795.cljs$lang$maxFixedArity = 2;

sablono.core.date_field = sablono.core.wrap_attrs.call(null,sablono.core.date_field25795);

/**
 * Creates a datetime input field.
 */
sablono.core.datetime_field25799 = (function sablono$core$datetime_field25799(var_args){
var args25800 = [];
var len__17507__auto___25867 = arguments.length;
var i__17508__auto___25868 = (0);
while(true){
if((i__17508__auto___25868 < len__17507__auto___25867)){
args25800.push((arguments[i__17508__auto___25868]));

var G__25869 = (i__17508__auto___25868 + (1));
i__17508__auto___25868 = G__25869;
continue;
} else {
}
break;
}

var G__25802 = args25800.length;
switch (G__25802) {
case 1:
return sablono.core.datetime_field25799.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_field25799.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25800.length)].join('')));

}
});

sablono.core.datetime_field25799.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.datetime_field25799.call(null,name__23007__auto__,null);
});

sablono.core.datetime_field25799.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"datetime","datetime",2135207229,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.datetime_field25799.cljs$lang$maxFixedArity = 2;

sablono.core.datetime_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_field25799);

/**
 * Creates a datetime-local input field.
 */
sablono.core.datetime_local_field25803 = (function sablono$core$datetime_local_field25803(var_args){
var args25804 = [];
var len__17507__auto___25871 = arguments.length;
var i__17508__auto___25872 = (0);
while(true){
if((i__17508__auto___25872 < len__17507__auto___25871)){
args25804.push((arguments[i__17508__auto___25872]));

var G__25873 = (i__17508__auto___25872 + (1));
i__17508__auto___25872 = G__25873;
continue;
} else {
}
break;
}

var G__25806 = args25804.length;
switch (G__25806) {
case 1:
return sablono.core.datetime_local_field25803.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_local_field25803.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25804.length)].join('')));

}
});

sablono.core.datetime_local_field25803.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.datetime_local_field25803.call(null,name__23007__auto__,null);
});

sablono.core.datetime_local_field25803.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"datetime-local","datetime-local",-507312697,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.datetime_local_field25803.cljs$lang$maxFixedArity = 2;

sablono.core.datetime_local_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_local_field25803);

/**
 * Creates a email input field.
 */
sablono.core.email_field25807 = (function sablono$core$email_field25807(var_args){
var args25808 = [];
var len__17507__auto___25875 = arguments.length;
var i__17508__auto___25876 = (0);
while(true){
if((i__17508__auto___25876 < len__17507__auto___25875)){
args25808.push((arguments[i__17508__auto___25876]));

var G__25877 = (i__17508__auto___25876 + (1));
i__17508__auto___25876 = G__25877;
continue;
} else {
}
break;
}

var G__25810 = args25808.length;
switch (G__25810) {
case 1:
return sablono.core.email_field25807.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.email_field25807.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25808.length)].join('')));

}
});

sablono.core.email_field25807.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.email_field25807.call(null,name__23007__auto__,null);
});

sablono.core.email_field25807.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"email","email",-1238619063,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.email_field25807.cljs$lang$maxFixedArity = 2;

sablono.core.email_field = sablono.core.wrap_attrs.call(null,sablono.core.email_field25807);

/**
 * Creates a file input field.
 */
sablono.core.file_field25811 = (function sablono$core$file_field25811(var_args){
var args25812 = [];
var len__17507__auto___25879 = arguments.length;
var i__17508__auto___25880 = (0);
while(true){
if((i__17508__auto___25880 < len__17507__auto___25879)){
args25812.push((arguments[i__17508__auto___25880]));

var G__25881 = (i__17508__auto___25880 + (1));
i__17508__auto___25880 = G__25881;
continue;
} else {
}
break;
}

var G__25814 = args25812.length;
switch (G__25814) {
case 1:
return sablono.core.file_field25811.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.file_field25811.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25812.length)].join('')));

}
});

sablono.core.file_field25811.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.file_field25811.call(null,name__23007__auto__,null);
});

sablono.core.file_field25811.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"file","file",370885649,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.file_field25811.cljs$lang$maxFixedArity = 2;

sablono.core.file_field = sablono.core.wrap_attrs.call(null,sablono.core.file_field25811);

/**
 * Creates a hidden input field.
 */
sablono.core.hidden_field25815 = (function sablono$core$hidden_field25815(var_args){
var args25816 = [];
var len__17507__auto___25883 = arguments.length;
var i__17508__auto___25884 = (0);
while(true){
if((i__17508__auto___25884 < len__17507__auto___25883)){
args25816.push((arguments[i__17508__auto___25884]));

var G__25885 = (i__17508__auto___25884 + (1));
i__17508__auto___25884 = G__25885;
continue;
} else {
}
break;
}

var G__25818 = args25816.length;
switch (G__25818) {
case 1:
return sablono.core.hidden_field25815.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.hidden_field25815.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25816.length)].join('')));

}
});

sablono.core.hidden_field25815.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.hidden_field25815.call(null,name__23007__auto__,null);
});

sablono.core.hidden_field25815.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"hidden","hidden",1328025435,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.hidden_field25815.cljs$lang$maxFixedArity = 2;

sablono.core.hidden_field = sablono.core.wrap_attrs.call(null,sablono.core.hidden_field25815);

/**
 * Creates a month input field.
 */
sablono.core.month_field25819 = (function sablono$core$month_field25819(var_args){
var args25820 = [];
var len__17507__auto___25887 = arguments.length;
var i__17508__auto___25888 = (0);
while(true){
if((i__17508__auto___25888 < len__17507__auto___25887)){
args25820.push((arguments[i__17508__auto___25888]));

var G__25889 = (i__17508__auto___25888 + (1));
i__17508__auto___25888 = G__25889;
continue;
} else {
}
break;
}

var G__25822 = args25820.length;
switch (G__25822) {
case 1:
return sablono.core.month_field25819.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.month_field25819.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25820.length)].join('')));

}
});

sablono.core.month_field25819.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.month_field25819.call(null,name__23007__auto__,null);
});

sablono.core.month_field25819.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"month","month",-319717006,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.month_field25819.cljs$lang$maxFixedArity = 2;

sablono.core.month_field = sablono.core.wrap_attrs.call(null,sablono.core.month_field25819);

/**
 * Creates a number input field.
 */
sablono.core.number_field25823 = (function sablono$core$number_field25823(var_args){
var args25824 = [];
var len__17507__auto___25891 = arguments.length;
var i__17508__auto___25892 = (0);
while(true){
if((i__17508__auto___25892 < len__17507__auto___25891)){
args25824.push((arguments[i__17508__auto___25892]));

var G__25893 = (i__17508__auto___25892 + (1));
i__17508__auto___25892 = G__25893;
continue;
} else {
}
break;
}

var G__25826 = args25824.length;
switch (G__25826) {
case 1:
return sablono.core.number_field25823.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.number_field25823.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25824.length)].join('')));

}
});

sablono.core.number_field25823.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.number_field25823.call(null,name__23007__auto__,null);
});

sablono.core.number_field25823.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"number","number",-1084057331,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.number_field25823.cljs$lang$maxFixedArity = 2;

sablono.core.number_field = sablono.core.wrap_attrs.call(null,sablono.core.number_field25823);

/**
 * Creates a password input field.
 */
sablono.core.password_field25827 = (function sablono$core$password_field25827(var_args){
var args25828 = [];
var len__17507__auto___25895 = arguments.length;
var i__17508__auto___25896 = (0);
while(true){
if((i__17508__auto___25896 < len__17507__auto___25895)){
args25828.push((arguments[i__17508__auto___25896]));

var G__25897 = (i__17508__auto___25896 + (1));
i__17508__auto___25896 = G__25897;
continue;
} else {
}
break;
}

var G__25830 = args25828.length;
switch (G__25830) {
case 1:
return sablono.core.password_field25827.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.password_field25827.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25828.length)].join('')));

}
});

sablono.core.password_field25827.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.password_field25827.call(null,name__23007__auto__,null);
});

sablono.core.password_field25827.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"password","password",2057553998,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.password_field25827.cljs$lang$maxFixedArity = 2;

sablono.core.password_field = sablono.core.wrap_attrs.call(null,sablono.core.password_field25827);

/**
 * Creates a range input field.
 */
sablono.core.range_field25831 = (function sablono$core$range_field25831(var_args){
var args25832 = [];
var len__17507__auto___25899 = arguments.length;
var i__17508__auto___25900 = (0);
while(true){
if((i__17508__auto___25900 < len__17507__auto___25899)){
args25832.push((arguments[i__17508__auto___25900]));

var G__25901 = (i__17508__auto___25900 + (1));
i__17508__auto___25900 = G__25901;
continue;
} else {
}
break;
}

var G__25834 = args25832.length;
switch (G__25834) {
case 1:
return sablono.core.range_field25831.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.range_field25831.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25832.length)].join('')));

}
});

sablono.core.range_field25831.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.range_field25831.call(null,name__23007__auto__,null);
});

sablono.core.range_field25831.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"range","range",-1014743483,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.range_field25831.cljs$lang$maxFixedArity = 2;

sablono.core.range_field = sablono.core.wrap_attrs.call(null,sablono.core.range_field25831);

/**
 * Creates a search input field.
 */
sablono.core.search_field25835 = (function sablono$core$search_field25835(var_args){
var args25836 = [];
var len__17507__auto___25903 = arguments.length;
var i__17508__auto___25904 = (0);
while(true){
if((i__17508__auto___25904 < len__17507__auto___25903)){
args25836.push((arguments[i__17508__auto___25904]));

var G__25905 = (i__17508__auto___25904 + (1));
i__17508__auto___25904 = G__25905;
continue;
} else {
}
break;
}

var G__25838 = args25836.length;
switch (G__25838) {
case 1:
return sablono.core.search_field25835.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.search_field25835.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25836.length)].join('')));

}
});

sablono.core.search_field25835.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.search_field25835.call(null,name__23007__auto__,null);
});

sablono.core.search_field25835.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"search","search",-1089495947,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.search_field25835.cljs$lang$maxFixedArity = 2;

sablono.core.search_field = sablono.core.wrap_attrs.call(null,sablono.core.search_field25835);

/**
 * Creates a tel input field.
 */
sablono.core.tel_field25839 = (function sablono$core$tel_field25839(var_args){
var args25840 = [];
var len__17507__auto___25907 = arguments.length;
var i__17508__auto___25908 = (0);
while(true){
if((i__17508__auto___25908 < len__17507__auto___25907)){
args25840.push((arguments[i__17508__auto___25908]));

var G__25909 = (i__17508__auto___25908 + (1));
i__17508__auto___25908 = G__25909;
continue;
} else {
}
break;
}

var G__25842 = args25840.length;
switch (G__25842) {
case 1:
return sablono.core.tel_field25839.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.tel_field25839.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25840.length)].join('')));

}
});

sablono.core.tel_field25839.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.tel_field25839.call(null,name__23007__auto__,null);
});

sablono.core.tel_field25839.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"tel","tel",1864669686,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.tel_field25839.cljs$lang$maxFixedArity = 2;

sablono.core.tel_field = sablono.core.wrap_attrs.call(null,sablono.core.tel_field25839);

/**
 * Creates a text input field.
 */
sablono.core.text_field25843 = (function sablono$core$text_field25843(var_args){
var args25844 = [];
var len__17507__auto___25911 = arguments.length;
var i__17508__auto___25912 = (0);
while(true){
if((i__17508__auto___25912 < len__17507__auto___25911)){
args25844.push((arguments[i__17508__auto___25912]));

var G__25913 = (i__17508__auto___25912 + (1));
i__17508__auto___25912 = G__25913;
continue;
} else {
}
break;
}

var G__25846 = args25844.length;
switch (G__25846) {
case 1:
return sablono.core.text_field25843.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_field25843.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25844.length)].join('')));

}
});

sablono.core.text_field25843.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.text_field25843.call(null,name__23007__auto__,null);
});

sablono.core.text_field25843.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"text","text",-150030170,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.text_field25843.cljs$lang$maxFixedArity = 2;

sablono.core.text_field = sablono.core.wrap_attrs.call(null,sablono.core.text_field25843);

/**
 * Creates a time input field.
 */
sablono.core.time_field25847 = (function sablono$core$time_field25847(var_args){
var args25848 = [];
var len__17507__auto___25915 = arguments.length;
var i__17508__auto___25916 = (0);
while(true){
if((i__17508__auto___25916 < len__17507__auto___25915)){
args25848.push((arguments[i__17508__auto___25916]));

var G__25917 = (i__17508__auto___25916 + (1));
i__17508__auto___25916 = G__25917;
continue;
} else {
}
break;
}

var G__25850 = args25848.length;
switch (G__25850) {
case 1:
return sablono.core.time_field25847.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.time_field25847.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25848.length)].join('')));

}
});

sablono.core.time_field25847.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.time_field25847.call(null,name__23007__auto__,null);
});

sablono.core.time_field25847.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"time","time",-1268547887,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.time_field25847.cljs$lang$maxFixedArity = 2;

sablono.core.time_field = sablono.core.wrap_attrs.call(null,sablono.core.time_field25847);

/**
 * Creates a url input field.
 */
sablono.core.url_field25851 = (function sablono$core$url_field25851(var_args){
var args25852 = [];
var len__17507__auto___25919 = arguments.length;
var i__17508__auto___25920 = (0);
while(true){
if((i__17508__auto___25920 < len__17507__auto___25919)){
args25852.push((arguments[i__17508__auto___25920]));

var G__25921 = (i__17508__auto___25920 + (1));
i__17508__auto___25920 = G__25921;
continue;
} else {
}
break;
}

var G__25854 = args25852.length;
switch (G__25854) {
case 1:
return sablono.core.url_field25851.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.url_field25851.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25852.length)].join('')));

}
});

sablono.core.url_field25851.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.url_field25851.call(null,name__23007__auto__,null);
});

sablono.core.url_field25851.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"url","url",1916828573,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.url_field25851.cljs$lang$maxFixedArity = 2;

sablono.core.url_field = sablono.core.wrap_attrs.call(null,sablono.core.url_field25851);

/**
 * Creates a week input field.
 */
sablono.core.week_field25855 = (function sablono$core$week_field25855(var_args){
var args25856 = [];
var len__17507__auto___25923 = arguments.length;
var i__17508__auto___25924 = (0);
while(true){
if((i__17508__auto___25924 < len__17507__auto___25923)){
args25856.push((arguments[i__17508__auto___25924]));

var G__25925 = (i__17508__auto___25924 + (1));
i__17508__auto___25924 = G__25925;
continue;
} else {
}
break;
}

var G__25858 = args25856.length;
switch (G__25858) {
case 1:
return sablono.core.week_field25855.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.week_field25855.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25856.length)].join('')));

}
});

sablono.core.week_field25855.cljs$core$IFn$_invoke$arity$1 = (function (name__23007__auto__){
return sablono.core.week_field25855.call(null,name__23007__auto__,null);
});

sablono.core.week_field25855.cljs$core$IFn$_invoke$arity$2 = (function (name__23007__auto__,value__23008__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str(new cljs.core.Symbol(null,"week","week",314058249,null))].join(''),name__23007__auto__,value__23008__auto__);
});

sablono.core.week_field25855.cljs$lang$maxFixedArity = 2;

sablono.core.week_field = sablono.core.wrap_attrs.call(null,sablono.core.week_field25855);
sablono.core.file_upload = sablono.core.file_field;
/**
 * Creates a check box.
 */
sablono.core.check_box25927 = (function sablono$core$check_box25927(var_args){
var args25928 = [];
var len__17507__auto___25931 = arguments.length;
var i__17508__auto___25932 = (0);
while(true){
if((i__17508__auto___25932 < len__17507__auto___25931)){
args25928.push((arguments[i__17508__auto___25932]));

var G__25933 = (i__17508__auto___25932 + (1));
i__17508__auto___25932 = G__25933;
continue;
} else {
}
break;
}

var G__25930 = args25928.length;
switch (G__25930) {
case 1:
return sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25928.length)].join('')));

}
});

sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$1 = (function (name){
return sablono.core.check_box25927.call(null,name,null);
});

sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$2 = (function (name,checked_QMARK_){
return sablono.core.check_box25927.call(null,name,checked_QMARK_,"true");
});

sablono.core.check_box25927.cljs$core$IFn$_invoke$arity$3 = (function (name,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"checkbox",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),value,new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.check_box25927.cljs$lang$maxFixedArity = 3;

sablono.core.check_box = sablono.core.wrap_attrs.call(null,sablono.core.check_box25927);
/**
 * Creates a radio button.
 */
sablono.core.radio_button25935 = (function sablono$core$radio_button25935(var_args){
var args25936 = [];
var len__17507__auto___25939 = arguments.length;
var i__17508__auto___25940 = (0);
while(true){
if((i__17508__auto___25940 < len__17507__auto___25939)){
args25936.push((arguments[i__17508__auto___25940]));

var G__25941 = (i__17508__auto___25940 + (1));
i__17508__auto___25940 = G__25941;
continue;
} else {
}
break;
}

var G__25938 = args25936.length;
switch (G__25938) {
case 1:
return sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25936.length)].join('')));

}
});

sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$1 = (function (group){
return sablono.core.radio_button25935.call(null,group,null);
});

sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$2 = (function (group,checked_QMARK_){
return sablono.core.radio_button25935.call(null,group,checked_QMARK_,"true");
});

sablono.core.radio_button25935.cljs$core$IFn$_invoke$arity$3 = (function (group,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"radio",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,group),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,[cljs.core.str(sablono.util.as_str.call(null,group)),cljs.core.str("-"),cljs.core.str(sablono.util.as_str.call(null,value))].join('')),new cljs.core.Keyword(null,"value","value",305978217),value,new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.radio_button25935.cljs$lang$maxFixedArity = 3;

sablono.core.radio_button = sablono.core.wrap_attrs.call(null,sablono.core.radio_button25935);
sablono.core.hash_key = (function sablono$core$hash_key(x){
return goog.string.hashCode(cljs.core.pr_str.call(null,x));
});
/**
 * Creates a seq of option tags from a collection.
 */
sablono.core.select_options25943 = (function sablono$core$select_options25943(coll){
var iter__17221__auto__ = (function sablono$core$select_options25943_$_iter__25952(s__25953){
return (new cljs.core.LazySeq(null,(function (){
var s__25953__$1 = s__25953;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__25953__$1);
if(temp__4425__auto__){
var s__25953__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__25953__$2)){
var c__17219__auto__ = cljs.core.chunk_first.call(null,s__25953__$2);
var size__17220__auto__ = cljs.core.count.call(null,c__17219__auto__);
var b__25955 = cljs.core.chunk_buffer.call(null,size__17220__auto__);
if((function (){var i__25954 = (0);
while(true){
if((i__25954 < size__17220__auto__)){
var x = cljs.core._nth.call(null,c__17219__auto__,i__25954);
cljs.core.chunk_append.call(null,b__25955,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__25958 = x;
var text = cljs.core.nth.call(null,vec__25958,(0),null);
var val = cljs.core.nth.call(null,vec__25958,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__25958,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono$core$select_options25943.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)));

var G__25960 = (i__25954 + (1));
i__25954 = G__25960;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25955),sablono$core$select_options25943_$_iter__25952.call(null,cljs.core.chunk_rest.call(null,s__25953__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__25955),null);
}
} else {
var x = cljs.core.first.call(null,s__25953__$2);
return cljs.core.cons.call(null,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__25959 = x;
var text = cljs.core.nth.call(null,vec__25959,(0),null);
var val = cljs.core.nth.call(null,vec__25959,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__25959,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono$core$select_options25943.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)),sablono$core$select_options25943_$_iter__25952.call(null,cljs.core.rest.call(null,s__25953__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__17221__auto__.call(null,coll);
});

sablono.core.select_options = sablono.core.wrap_attrs.call(null,sablono.core.select_options25943);
/**
 * Creates a drop-down box using the <select> tag.
 */
sablono.core.drop_down25961 = (function sablono$core$drop_down25961(var_args){
var args25962 = [];
var len__17507__auto___25965 = arguments.length;
var i__17508__auto___25966 = (0);
while(true){
if((i__17508__auto___25966 < len__17507__auto___25965)){
args25962.push((arguments[i__17508__auto___25966]));

var G__25967 = (i__17508__auto___25966 + (1));
i__17508__auto___25966 = G__25967;
continue;
} else {
}
break;
}

var G__25964 = args25962.length;
switch (G__25964) {
case 2:
return sablono.core.drop_down25961.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.drop_down25961.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25962.length)].join('')));

}
});

sablono.core.drop_down25961.cljs$core$IFn$_invoke$arity$2 = (function (name,options){
return sablono.core.drop_down25961.call(null,name,options,null);
});

sablono.core.drop_down25961.cljs$core$IFn$_invoke$arity$3 = (function (name,options,selected){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null),sablono.core.select_options.call(null,options,selected)], null);
});

sablono.core.drop_down25961.cljs$lang$maxFixedArity = 3;

sablono.core.drop_down = sablono.core.wrap_attrs.call(null,sablono.core.drop_down25961);
/**
 * Creates a text area element.
 */
sablono.core.text_area25969 = (function sablono$core$text_area25969(var_args){
var args25970 = [];
var len__17507__auto___25973 = arguments.length;
var i__17508__auto___25974 = (0);
while(true){
if((i__17508__auto___25974 < len__17507__auto___25973)){
args25970.push((arguments[i__17508__auto___25974]));

var G__25975 = (i__17508__auto___25974 + (1));
i__17508__auto___25974 = G__25975;
continue;
} else {
}
break;
}

var G__25972 = args25970.length;
switch (G__25972) {
case 1:
return sablono.core.text_area25969.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_area25969.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25970.length)].join('')));

}
});

sablono.core.text_area25969.cljs$core$IFn$_invoke$arity$1 = (function (name){
return sablono.core.text_area25969.call(null,name,null);
});

sablono.core.text_area25969.cljs$core$IFn$_invoke$arity$2 = (function (name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"textarea","textarea",-650375824),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),value], null)], null);
});

sablono.core.text_area25969.cljs$lang$maxFixedArity = 2;

sablono.core.text_area = sablono.core.wrap_attrs.call(null,sablono.core.text_area25969);
/**
 * Creates a label for an input field with the supplied name.
 */
sablono.core.label25977 = (function sablono$core$label25977(name,text){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"label","label",1718410804),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"htmlFor","htmlFor",-1050291720),sablono.core.make_id.call(null,name)], null),text], null);
});

sablono.core.label = sablono.core.wrap_attrs.call(null,sablono.core.label25977);
/**
 * Creates a submit button.
 */
sablono.core.submit_button25978 = (function sablono$core$submit_button25978(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"submit",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.submit_button = sablono.core.wrap_attrs.call(null,sablono.core.submit_button25978);
/**
 * Creates a form reset button.
 */
sablono.core.reset_button25979 = (function sablono$core$reset_button25979(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"reset",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.reset_button = sablono.core.wrap_attrs.call(null,sablono.core.reset_button25979);
/**
 * Create a form that points to a particular method and route.
 *   e.g. (form-to [:put "/post"]
 *       ...)
 */
sablono.core.form_to25980 = (function sablono$core$form_to25980(var_args){
var args__17514__auto__ = [];
var len__17507__auto___25985 = arguments.length;
var i__17508__auto___25986 = (0);
while(true){
if((i__17508__auto___25986 < len__17507__auto___25985)){
args__17514__auto__.push((arguments[i__17508__auto___25986]));

var G__25987 = (i__17508__auto___25986 + (1));
i__17508__auto___25986 = G__25987;
continue;
} else {
}
break;
}

var argseq__17515__auto__ = ((((1) < args__17514__auto__.length))?(new cljs.core.IndexedSeq(args__17514__auto__.slice((1)),(0))):null);
return sablono.core.form_to25980.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__17515__auto__);
});

sablono.core.form_to25980.cljs$core$IFn$_invoke$arity$variadic = (function (p__25983,body){
var vec__25984 = p__25983;
var method = cljs.core.nth.call(null,vec__25984,(0),null);
var action = cljs.core.nth.call(null,vec__25984,(1),null);
var method_str = clojure.string.upper_case.call(null,cljs.core.name.call(null,method));
var action_uri = sablono.util.to_uri.call(null,action);
return cljs.core.vec.call(null,cljs.core.concat.call(null,((cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"get","get",1683182755),null,new cljs.core.Keyword(null,"post","post",269697687),null], null), null),method))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),method_str,new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null)], null):new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),"POST",new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null),sablono.core.hidden_field.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),(3735928559)], null),"_method",method_str)], null)),body));
});

sablono.core.form_to25980.cljs$lang$maxFixedArity = (1);

sablono.core.form_to25980.cljs$lang$applyTo = (function (seq25981){
var G__25982 = cljs.core.first.call(null,seq25981);
var seq25981__$1 = cljs.core.next.call(null,seq25981);
return sablono.core.form_to25980.cljs$core$IFn$_invoke$arity$variadic(G__25982,seq25981__$1);
});

sablono.core.form_to = sablono.core.wrap_attrs.call(null,sablono.core.form_to25980);

//# sourceMappingURL=core.js.map