// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('tubax.helpers');
goog.require('cljs.core');
/**
 * Checks if the parameter matchs the tubax node contract
 */
tubax.helpers.is_node = (function tubax$helpers$is_node(node){
return (cljs.core.map_QMARK_.call(null,node)) && (cljs.core.contains_QMARK_.call(null,node,new cljs.core.Keyword(null,"tag","tag",-1290361223))) && ((new cljs.core.Keyword(null,"tag","tag",-1290361223).cljs$core$IFn$_invoke$arity$1(node) instanceof cljs.core.Keyword)) && (cljs.core.contains_QMARK_.call(null,node,new cljs.core.Keyword(null,"attributes","attributes",-74013604))) && (cljs.core.map_QMARK_.call(null,new cljs.core.Keyword(null,"attributes","attributes",-74013604).cljs$core$IFn$_invoke$arity$1(node))) && (cljs.core.contains_QMARK_.call(null,node,new cljs.core.Keyword(null,"content","content",15833224))) && (cljs.core.vector_QMARK_.call(null,new cljs.core.Keyword(null,"content","content",15833224).cljs$core$IFn$_invoke$arity$1(node)));
});
tubax.helpers.tag = (function tubax$helpers$tag(p__26292){
var map__26295 = p__26292;
var map__26295__$1 = ((((!((map__26295 == null)))?((((map__26295.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26295.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26295):map__26295);
var tag__$1 = cljs.core.get.call(null,map__26295__$1,new cljs.core.Keyword(null,"tag","tag",-1290361223));
return tag__$1;
});
tubax.helpers.attributes = (function tubax$helpers$attributes(p__26297){
var map__26300 = p__26297;
var map__26300__$1 = ((((!((map__26300 == null)))?((((map__26300.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26300.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26300):map__26300);
var attributes__$1 = cljs.core.get.call(null,map__26300__$1,new cljs.core.Keyword(null,"attributes","attributes",-74013604));
return attributes__$1;
});
tubax.helpers.children = (function tubax$helpers$children(p__26302){
var map__26305 = p__26302;
var map__26305__$1 = ((((!((map__26305 == null)))?((((map__26305.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26305.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26305):map__26305);
var content = cljs.core.get.call(null,map__26305__$1,new cljs.core.Keyword(null,"content","content",15833224));
return content;
});
tubax.helpers.text = (function tubax$helpers$text(node){
var vec__26308 = tubax.helpers.children.call(null,node);
var value = cljs.core.nth.call(null,vec__26308,(0),null);
var _ = cljs.core.nthnext.call(null,vec__26308,(1));
if(typeof value === 'string'){
return value;
} else {
return null;
}
});
tubax.helpers.seq_tree = (function tubax$helpers$seq_tree(tree){
return cljs.core.tree_seq.call(null,tubax.helpers.is_node,tubax.helpers.children,tree);
});
tubax.helpers.filter_tree = (function tubax$helpers$filter_tree(search_fn,tree){
return cljs.core.filter.call(null,search_fn,tubax.helpers.seq_tree.call(null,tree));
});
tubax.helpers.first_tree = (function tubax$helpers$first_tree(search_fn,tree){
return cljs.core.first.call(null,tubax.helpers.filter_tree.call(null,search_fn,tree));
});
tubax.helpers.find_first_by_path = (function tubax$helpers$find_first_by_path(path_left,node){
while(true){
if(cljs.core.empty_QMARK_.call(null,path_left)){
return node;
} else {
if((node == null)){
return null;
} else {
if(typeof node === 'string'){
return null;
} else {
var subtree = cljs.core.some.call(null,((function (path_left,node){
return (function (p1__26309_SHARP_){
if(cljs.core._EQ_.call(null,tubax.helpers.tag.call(null,p1__26309_SHARP_),cljs.core.first.call(null,path_left))){
return p1__26309_SHARP_;
} else {
return null;
}
});})(path_left,node))
,tubax.helpers.children.call(null,node));
var G__26310 = cljs.core.rest.call(null,path_left);
var G__26311 = subtree;
path_left = G__26310;
node = G__26311;
continue;

}
}
}
break;
}
});
tubax.helpers.find_all_by_path = (function tubax$helpers$find_all_by_path(path,node){
if(cljs.core.empty_QMARK_.call(null,path)){
return cljs.core.List.EMPTY;
} else {
if((cljs.core._EQ_.call(null,cljs.core.count.call(null,path),(1))) && (cljs.core._EQ_.call(null,tubax.helpers.tag.call(null,node),cljs.core.first.call(null,path)))){
return cljs.core._conj.call(null,cljs.core.List.EMPTY,node);
} else {
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,path),(1))){
return cljs.core.List.EMPTY;
} else {
if(cljs.core._EQ_.call(null,tubax.helpers.tag.call(null,node),cljs.core.first.call(null,path))){
return cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.partial.call(null,tubax$helpers$find_all_by_path,cljs.core.rest.call(null,path)),tubax.helpers.children.call(null,node)));
} else {
return cljs.core.List.EMPTY;
}

}
}
}
});
tubax.helpers.find_multi_dispatcher = (function tubax$helpers$find_multi_dispatcher(_,param){
var key = cljs.core.first.call(null,cljs.core.keys.call(null,param));
if((cljs.core._EQ_.call(null,key,new cljs.core.Keyword(null,"attribute","attribute",-2074029119))) && ((cljs.core.get.call(null,param,key) instanceof cljs.core.Keyword))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"keyword","keyword",811389747)], null);
} else {
if((cljs.core._EQ_.call(null,key,new cljs.core.Keyword(null,"attribute","attribute",-2074029119))) && (cljs.core.vector_QMARK_.call(null,cljs.core.get.call(null,param,key)))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"vector","vector",1902966158)], null);
} else {
return key;

}
}
});
if(typeof tubax.helpers.find_first !== 'undefined'){
} else {
tubax.helpers.find_first = (function (){var method_table__17309__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__17310__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__17311__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__17312__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__17313__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"tubax.helpers","find-first"),tubax.helpers.find_multi_dispatcher,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__17313__auto__,method_table__17309__auto__,prefer_table__17310__auto__,method_cache__17311__auto__,cached_hierarchy__17312__auto__));
})();
}
cljs.core._add_method.call(null,tubax.helpers.find_first,new cljs.core.Keyword(null,"tag","tag",-1290361223),(function (tree,param){
return tubax.helpers.first_tree.call(null,(function (p1__26312_SHARP_){
return cljs.core._EQ_.call(null,tubax.helpers.tag.call(null,p1__26312_SHARP_),new cljs.core.Keyword(null,"tag","tag",-1290361223).cljs$core$IFn$_invoke$arity$1(param));
}),tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_first,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"keyword","keyword",811389747)], null),(function (tree,param){
return tubax.helpers.first_tree.call(null,(function (p1__26313_SHARP_){
return cljs.core.contains_QMARK_.call(null,tubax.helpers.attributes.call(null,p1__26313_SHARP_),new cljs.core.Keyword(null,"attribute","attribute",-2074029119).cljs$core$IFn$_invoke$arity$1(param));
}),tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_first,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"vector","vector",1902966158)], null),(function (tree,param){
var vec__26315 = new cljs.core.Keyword(null,"attribute","attribute",-2074029119).cljs$core$IFn$_invoke$arity$1(param);
var key = cljs.core.nth.call(null,vec__26315,(0),null);
var value = cljs.core.nth.call(null,vec__26315,(1),null);
return tubax.helpers.first_tree.call(null,((function (vec__26315,key,value){
return (function (p1__26314_SHARP_){
return (cljs.core.contains_QMARK_.call(null,tubax.helpers.attributes.call(null,p1__26314_SHARP_),key)) && (cljs.core._EQ_.call(null,cljs.core.get.call(null,tubax.helpers.attributes.call(null,p1__26314_SHARP_),key),value));
});})(vec__26315,key,value))
,tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_first,new cljs.core.Keyword(null,"path","path",-188191168),(function (tree,p__26316){
var map__26317 = p__26316;
var map__26317__$1 = ((((!((map__26317 == null)))?((((map__26317.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26317.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26317):map__26317);
var path = cljs.core.get.call(null,map__26317__$1,new cljs.core.Keyword(null,"path","path",-188191168));
if((!(cljs.core.empty_QMARK_.call(null,path))) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,path),tubax.helpers.tag.call(null,tree)))){
return tubax.helpers.find_first_by_path.call(null,cljs.core.rest.call(null,path),tree);
} else {
return null;
}
}));
if(typeof tubax.helpers.find_all !== 'undefined'){
} else {
tubax.helpers.find_all = (function (){var method_table__17309__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__17310__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__17311__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__17312__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__17313__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"tubax.helpers","find-all"),tubax.helpers.find_multi_dispatcher,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__17313__auto__,method_table__17309__auto__,prefer_table__17310__auto__,method_cache__17311__auto__,cached_hierarchy__17312__auto__));
})();
}
cljs.core._add_method.call(null,tubax.helpers.find_all,new cljs.core.Keyword(null,"tag","tag",-1290361223),(function (tree,param){
return tubax.helpers.filter_tree.call(null,(function (p1__26319_SHARP_){
return cljs.core._EQ_.call(null,tubax.helpers.tag.call(null,p1__26319_SHARP_),new cljs.core.Keyword(null,"tag","tag",-1290361223).cljs$core$IFn$_invoke$arity$1(param));
}),tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_all,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"keyword","keyword",811389747)], null),(function (tree,param){
return tubax.helpers.filter_tree.call(null,(function (p1__26320_SHARP_){
return cljs.core.contains_QMARK_.call(null,tubax.helpers.attributes.call(null,p1__26320_SHARP_),new cljs.core.Keyword(null,"attribute","attribute",-2074029119).cljs$core$IFn$_invoke$arity$1(param));
}),tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_all,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"attribute","attribute",-2074029119),new cljs.core.Keyword(null,"vector","vector",1902966158)], null),(function (tree,param){
var vec__26322 = new cljs.core.Keyword(null,"attribute","attribute",-2074029119).cljs$core$IFn$_invoke$arity$1(param);
var key = cljs.core.nth.call(null,vec__26322,(0),null);
var value = cljs.core.nth.call(null,vec__26322,(1),null);
return tubax.helpers.filter_tree.call(null,((function (vec__26322,key,value){
return (function (p1__26321_SHARP_){
return (cljs.core.contains_QMARK_.call(null,tubax.helpers.attributes.call(null,p1__26321_SHARP_),key)) && (cljs.core._EQ_.call(null,cljs.core.get.call(null,tubax.helpers.attributes.call(null,p1__26321_SHARP_),key),value));
});})(vec__26322,key,value))
,tree);
}));
cljs.core._add_method.call(null,tubax.helpers.find_all,new cljs.core.Keyword(null,"path","path",-188191168),(function (tree,p__26323){
var map__26324 = p__26323;
var map__26324__$1 = ((((!((map__26324 == null)))?((((map__26324.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26324.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26324):map__26324);
var path = cljs.core.get.call(null,map__26324__$1,new cljs.core.Keyword(null,"path","path",-188191168));
return tubax.helpers.find_all_by_path.call(null,path,tree);
}));

//# sourceMappingURL=helpers.js.map