// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(f){
if(typeof cljs.core.async.t_cljs$core$async26313 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async26313 = (function (fn_handler,f,meta26314){
this.fn_handler = fn_handler;
this.f = f;
this.meta26314 = meta26314;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async26313.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_26315,meta26314__$1){
var self__ = this;
var _26315__$1 = this;
return (new cljs.core.async.t_cljs$core$async26313(self__.fn_handler,self__.f,meta26314__$1));
});

cljs.core.async.t_cljs$core$async26313.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_26315){
var self__ = this;
var _26315__$1 = this;
return self__.meta26314;
});

cljs.core.async.t_cljs$core$async26313.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async26313.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async26313.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async26313.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"fn-handler","fn-handler",648785851,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null)], null)))], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"meta26314","meta26314",53106451,null)], null);
});

cljs.core.async.t_cljs$core$async26313.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async26313.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async26313";

cljs.core.async.t_cljs$core$async26313.cljs$lang$ctorPrWriter = (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async26313");
});

cljs.core.async.__GT_t_cljs$core$async26313 = (function cljs$core$async$fn_handler_$___GT_t_cljs$core$async26313(fn_handler__$1,f__$1,meta26314){
return (new cljs.core.async.t_cljs$core$async26313(fn_handler__$1,f__$1,meta26314));
});

}

return (new cljs.core.async.t_cljs$core$async26313(cljs$core$async$fn_handler,f,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args26318 = [];
var len__17454__auto___26321 = arguments.length;
var i__17455__auto___26322 = (0);
while(true){
if((i__17455__auto___26322 < len__17454__auto___26321)){
args26318.push((arguments[i__17455__auto___26322]));

var G__26323 = (i__17455__auto___26322 + (1));
i__17455__auto___26322 = G__26323;
continue;
} else {
}
break;
}

var G__26320 = args26318.length;
switch (G__26320) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26318.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args26325 = [];
var len__17454__auto___26328 = arguments.length;
var i__17455__auto___26329 = (0);
while(true){
if((i__17455__auto___26329 < len__17454__auto___26328)){
args26325.push((arguments[i__17455__auto___26329]));

var G__26330 = (i__17455__auto___26329 + (1));
i__17455__auto___26329 = G__26330;
continue;
} else {
}
break;
}

var G__26327 = args26325.length;
switch (G__26327) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26325.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_26332 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_26332);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_26332,ret){
return (function (){
return fn1.call(null,val_26332);
});})(val_26332,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args26333 = [];
var len__17454__auto___26336 = arguments.length;
var i__17455__auto___26337 = (0);
while(true){
if((i__17455__auto___26337 < len__17454__auto___26336)){
args26333.push((arguments[i__17455__auto___26337]));

var G__26338 = (i__17455__auto___26337 + (1));
i__17455__auto___26337 = G__26338;
continue;
} else {
}
break;
}

var G__26335 = args26333.length;
switch (G__26335) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26333.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4423__auto__)){
var ret = temp__4423__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4423__auto__)){
var retb = temp__4423__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4423__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4423__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__17299__auto___26340 = n;
var x_26341 = (0);
while(true){
if((x_26341 < n__17299__auto___26340)){
(a[x_26341] = (0));

var G__26342 = (x_26341 + (1));
x_26341 = G__26342;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__26343 = (i + (1));
i = G__26343;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async26347 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async26347 = (function (alt_flag,flag,meta26348){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta26348 = meta26348;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async26347.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_26349,meta26348__$1){
var self__ = this;
var _26349__$1 = this;
return (new cljs.core.async.t_cljs$core$async26347(self__.alt_flag,self__.flag,meta26348__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async26347.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_26349){
var self__ = this;
var _26349__$1 = this;
return self__.meta26348;
});})(flag))
;

cljs.core.async.t_cljs$core$async26347.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async26347.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async26347.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async26347.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-flag","alt-flag",-1794972754,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta26348","meta26348",-1214340103,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async26347.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async26347.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async26347";

cljs.core.async.t_cljs$core$async26347.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async26347");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async26347 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async26347(alt_flag__$1,flag__$1,meta26348){
return (new cljs.core.async.t_cljs$core$async26347(alt_flag__$1,flag__$1,meta26348));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async26347(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async26353 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async26353 = (function (alt_handler,flag,cb,meta26354){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta26354 = meta26354;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async26353.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_26355,meta26354__$1){
var self__ = this;
var _26355__$1 = this;
return (new cljs.core.async.t_cljs$core$async26353(self__.alt_handler,self__.flag,self__.cb,meta26354__$1));
});

cljs.core.async.t_cljs$core$async26353.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_26355){
var self__ = this;
var _26355__$1 = this;
return self__.meta26354;
});

cljs.core.async.t_cljs$core$async26353.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async26353.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async26353.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async26353.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-handler","alt-handler",963786170,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null)], null)))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta26354","meta26354",1150197154,null)], null);
});

cljs.core.async.t_cljs$core$async26353.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async26353.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async26353";

cljs.core.async.t_cljs$core$async26353.cljs$lang$ctorPrWriter = (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async26353");
});

cljs.core.async.__GT_t_cljs$core$async26353 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async26353(alt_handler__$1,flag__$1,cb__$1,meta26354){
return (new cljs.core.async.t_cljs$core$async26353(alt_handler__$1,flag__$1,cb__$1,meta26354));
});

}

return (new cljs.core.async.t_cljs$core$async26353(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__26356_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__26356_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__26357_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__26357_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__16396__auto__ = wport;
if(cljs.core.truth_(or__16396__auto__)){
return or__16396__auto__;
} else {
return port;
}
})()], null));
} else {
var G__26358 = (i + (1));
i = G__26358;
continue;
}
} else {
return null;
}
break;
}
})();
var or__16396__auto__ = ret;
if(cljs.core.truth_(or__16396__auto__)){
return or__16396__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4425__auto__ = (function (){var and__16384__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__16384__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__16384__auto__;
}
})();
if(cljs.core.truth_(temp__4425__auto__)){
var got = temp__4425__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__17461__auto__ = [];
var len__17454__auto___26364 = arguments.length;
var i__17455__auto___26365 = (0);
while(true){
if((i__17455__auto___26365 < len__17454__auto___26364)){
args__17461__auto__.push((arguments[i__17455__auto___26365]));

var G__26366 = (i__17455__auto___26365 + (1));
i__17455__auto___26365 = G__26366;
continue;
} else {
}
break;
}

var argseq__17462__auto__ = ((((1) < args__17461__auto__.length))?(new cljs.core.IndexedSeq(args__17461__auto__.slice((1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__17462__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__26361){
var map__26362 = p__26361;
var map__26362__$1 = ((((!((map__26362 == null)))?((((map__26362.cljs$lang$protocol_mask$partition0$ & (64))) || (map__26362.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26362):map__26362);
var opts = map__26362__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq26359){
var G__26360 = cljs.core.first.call(null,seq26359);
var seq26359__$1 = cljs.core.next.call(null,seq26359);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__26360,seq26359__$1);
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args26367 = [];
var len__17454__auto___26417 = arguments.length;
var i__17455__auto___26418 = (0);
while(true){
if((i__17455__auto___26418 < len__17454__auto___26417)){
args26367.push((arguments[i__17455__auto___26418]));

var G__26419 = (i__17455__auto___26418 + (1));
i__17455__auto___26418 = G__26419;
continue;
} else {
}
break;
}

var G__26369 = args26367.length;
switch (G__26369) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26367.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__19725__auto___26421 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___26421){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___26421){
return (function (state_26393){
var state_val_26394 = (state_26393[(1)]);
if((state_val_26394 === (7))){
var inst_26389 = (state_26393[(2)]);
var state_26393__$1 = state_26393;
var statearr_26395_26422 = state_26393__$1;
(statearr_26395_26422[(2)] = inst_26389);

(statearr_26395_26422[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (1))){
var state_26393__$1 = state_26393;
var statearr_26396_26423 = state_26393__$1;
(statearr_26396_26423[(2)] = null);

(statearr_26396_26423[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (4))){
var inst_26372 = (state_26393[(7)]);
var inst_26372__$1 = (state_26393[(2)]);
var inst_26373 = (inst_26372__$1 == null);
var state_26393__$1 = (function (){var statearr_26397 = state_26393;
(statearr_26397[(7)] = inst_26372__$1);

return statearr_26397;
})();
if(cljs.core.truth_(inst_26373)){
var statearr_26398_26424 = state_26393__$1;
(statearr_26398_26424[(1)] = (5));

} else {
var statearr_26399_26425 = state_26393__$1;
(statearr_26399_26425[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (13))){
var state_26393__$1 = state_26393;
var statearr_26400_26426 = state_26393__$1;
(statearr_26400_26426[(2)] = null);

(statearr_26400_26426[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (6))){
var inst_26372 = (state_26393[(7)]);
var state_26393__$1 = state_26393;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26393__$1,(11),to,inst_26372);
} else {
if((state_val_26394 === (3))){
var inst_26391 = (state_26393[(2)]);
var state_26393__$1 = state_26393;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26393__$1,inst_26391);
} else {
if((state_val_26394 === (12))){
var state_26393__$1 = state_26393;
var statearr_26401_26427 = state_26393__$1;
(statearr_26401_26427[(2)] = null);

(statearr_26401_26427[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (2))){
var state_26393__$1 = state_26393;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26393__$1,(4),from);
} else {
if((state_val_26394 === (11))){
var inst_26382 = (state_26393[(2)]);
var state_26393__$1 = state_26393;
if(cljs.core.truth_(inst_26382)){
var statearr_26402_26428 = state_26393__$1;
(statearr_26402_26428[(1)] = (12));

} else {
var statearr_26403_26429 = state_26393__$1;
(statearr_26403_26429[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (9))){
var state_26393__$1 = state_26393;
var statearr_26404_26430 = state_26393__$1;
(statearr_26404_26430[(2)] = null);

(statearr_26404_26430[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (5))){
var state_26393__$1 = state_26393;
if(cljs.core.truth_(close_QMARK_)){
var statearr_26405_26431 = state_26393__$1;
(statearr_26405_26431[(1)] = (8));

} else {
var statearr_26406_26432 = state_26393__$1;
(statearr_26406_26432[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (14))){
var inst_26387 = (state_26393[(2)]);
var state_26393__$1 = state_26393;
var statearr_26407_26433 = state_26393__$1;
(statearr_26407_26433[(2)] = inst_26387);

(statearr_26407_26433[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (10))){
var inst_26379 = (state_26393[(2)]);
var state_26393__$1 = state_26393;
var statearr_26408_26434 = state_26393__$1;
(statearr_26408_26434[(2)] = inst_26379);

(statearr_26408_26434[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26394 === (8))){
var inst_26376 = cljs.core.async.close_BANG_.call(null,to);
var state_26393__$1 = state_26393;
var statearr_26409_26435 = state_26393__$1;
(statearr_26409_26435[(2)] = inst_26376);

(statearr_26409_26435[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___26421))
;
return ((function (switch__19660__auto__,c__19725__auto___26421){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_26413 = [null,null,null,null,null,null,null,null];
(statearr_26413[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_26413[(1)] = (1));

return statearr_26413;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_26393){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26393);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26414){if((e26414 instanceof Object)){
var ex__19664__auto__ = e26414;
var statearr_26415_26436 = state_26393;
(statearr_26415_26436[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26393);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26414;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26437 = state_26393;
state_26393 = G__26437;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_26393){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_26393);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___26421))
})();
var state__19727__auto__ = (function (){var statearr_26416 = f__19726__auto__.call(null);
(statearr_26416[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26421);

return statearr_26416;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___26421))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__26621){
var vec__26622 = p__26621;
var v = cljs.core.nth.call(null,vec__26622,(0),null);
var p = cljs.core.nth.call(null,vec__26622,(1),null);
var job = vec__26622;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__19725__auto___26804 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results){
return (function (state_26627){
var state_val_26628 = (state_26627[(1)]);
if((state_val_26628 === (1))){
var state_26627__$1 = state_26627;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26627__$1,(2),res,v);
} else {
if((state_val_26628 === (2))){
var inst_26624 = (state_26627[(2)]);
var inst_26625 = cljs.core.async.close_BANG_.call(null,res);
var state_26627__$1 = (function (){var statearr_26629 = state_26627;
(statearr_26629[(7)] = inst_26624);

return statearr_26629;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26627__$1,inst_26625);
} else {
return null;
}
}
});})(c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results))
;
return ((function (switch__19660__auto__,c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_26633 = [null,null,null,null,null,null,null,null];
(statearr_26633[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__);

(statearr_26633[(1)] = (1));

return statearr_26633;
});
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1 = (function (state_26627){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26627);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26634){if((e26634 instanceof Object)){
var ex__19664__auto__ = e26634;
var statearr_26635_26805 = state_26627;
(statearr_26635_26805[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26627);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26634;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26806 = state_26627;
state_26627 = G__26806;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = function(state_26627){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1.call(this,state_26627);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results))
})();
var state__19727__auto__ = (function (){var statearr_26636 = f__19726__auto__.call(null);
(statearr_26636[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26804);

return statearr_26636;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___26804,res,vec__26622,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__26637){
var vec__26638 = p__26637;
var v = cljs.core.nth.call(null,vec__26638,(0),null);
var p = cljs.core.nth.call(null,vec__26638,(1),null);
var job = vec__26638;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__17299__auto___26807 = n;
var __26808 = (0);
while(true){
if((__26808 < n__17299__auto___26807)){
var G__26639_26809 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__26639_26809) {
case "compute":
var c__19725__auto___26811 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__26808,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (__26808,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function (state_26652){
var state_val_26653 = (state_26652[(1)]);
if((state_val_26653 === (1))){
var state_26652__$1 = state_26652;
var statearr_26654_26812 = state_26652__$1;
(statearr_26654_26812[(2)] = null);

(statearr_26654_26812[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26653 === (2))){
var state_26652__$1 = state_26652;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26652__$1,(4),jobs);
} else {
if((state_val_26653 === (3))){
var inst_26650 = (state_26652[(2)]);
var state_26652__$1 = state_26652;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26652__$1,inst_26650);
} else {
if((state_val_26653 === (4))){
var inst_26642 = (state_26652[(2)]);
var inst_26643 = process.call(null,inst_26642);
var state_26652__$1 = state_26652;
if(cljs.core.truth_(inst_26643)){
var statearr_26655_26813 = state_26652__$1;
(statearr_26655_26813[(1)] = (5));

} else {
var statearr_26656_26814 = state_26652__$1;
(statearr_26656_26814[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26653 === (5))){
var state_26652__$1 = state_26652;
var statearr_26657_26815 = state_26652__$1;
(statearr_26657_26815[(2)] = null);

(statearr_26657_26815[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26653 === (6))){
var state_26652__$1 = state_26652;
var statearr_26658_26816 = state_26652__$1;
(statearr_26658_26816[(2)] = null);

(statearr_26658_26816[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26653 === (7))){
var inst_26648 = (state_26652[(2)]);
var state_26652__$1 = state_26652;
var statearr_26659_26817 = state_26652__$1;
(statearr_26659_26817[(2)] = inst_26648);

(statearr_26659_26817[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__26808,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
;
return ((function (__26808,switch__19660__auto__,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_26663 = [null,null,null,null,null,null,null];
(statearr_26663[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__);

(statearr_26663[(1)] = (1));

return statearr_26663;
});
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1 = (function (state_26652){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26652);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26664){if((e26664 instanceof Object)){
var ex__19664__auto__ = e26664;
var statearr_26665_26818 = state_26652;
(statearr_26665_26818[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26652);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26664;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26819 = state_26652;
state_26652 = G__26819;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = function(state_26652){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1.call(this,state_26652);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__;
})()
;})(__26808,switch__19660__auto__,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
})();
var state__19727__auto__ = (function (){var statearr_26666 = f__19726__auto__.call(null);
(statearr_26666[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26811);

return statearr_26666;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(__26808,c__19725__auto___26811,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
);


break;
case "async":
var c__19725__auto___26820 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__26808,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (__26808,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function (state_26679){
var state_val_26680 = (state_26679[(1)]);
if((state_val_26680 === (1))){
var state_26679__$1 = state_26679;
var statearr_26681_26821 = state_26679__$1;
(statearr_26681_26821[(2)] = null);

(statearr_26681_26821[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26680 === (2))){
var state_26679__$1 = state_26679;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26679__$1,(4),jobs);
} else {
if((state_val_26680 === (3))){
var inst_26677 = (state_26679[(2)]);
var state_26679__$1 = state_26679;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26679__$1,inst_26677);
} else {
if((state_val_26680 === (4))){
var inst_26669 = (state_26679[(2)]);
var inst_26670 = async.call(null,inst_26669);
var state_26679__$1 = state_26679;
if(cljs.core.truth_(inst_26670)){
var statearr_26682_26822 = state_26679__$1;
(statearr_26682_26822[(1)] = (5));

} else {
var statearr_26683_26823 = state_26679__$1;
(statearr_26683_26823[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26680 === (5))){
var state_26679__$1 = state_26679;
var statearr_26684_26824 = state_26679__$1;
(statearr_26684_26824[(2)] = null);

(statearr_26684_26824[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26680 === (6))){
var state_26679__$1 = state_26679;
var statearr_26685_26825 = state_26679__$1;
(statearr_26685_26825[(2)] = null);

(statearr_26685_26825[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26680 === (7))){
var inst_26675 = (state_26679[(2)]);
var state_26679__$1 = state_26679;
var statearr_26686_26826 = state_26679__$1;
(statearr_26686_26826[(2)] = inst_26675);

(statearr_26686_26826[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__26808,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
;
return ((function (__26808,switch__19660__auto__,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_26690 = [null,null,null,null,null,null,null];
(statearr_26690[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__);

(statearr_26690[(1)] = (1));

return statearr_26690;
});
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1 = (function (state_26679){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26679);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26691){if((e26691 instanceof Object)){
var ex__19664__auto__ = e26691;
var statearr_26692_26827 = state_26679;
(statearr_26692_26827[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26679);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26691;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26828 = state_26679;
state_26679 = G__26828;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = function(state_26679){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1.call(this,state_26679);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__;
})()
;})(__26808,switch__19660__auto__,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
})();
var state__19727__auto__ = (function (){var statearr_26693 = f__19726__auto__.call(null);
(statearr_26693[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26820);

return statearr_26693;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(__26808,c__19725__auto___26820,G__26639_26809,n__17299__auto___26807,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__26829 = (__26808 + (1));
__26808 = G__26829;
continue;
} else {
}
break;
}

var c__19725__auto___26830 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___26830,jobs,results,process,async){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___26830,jobs,results,process,async){
return (function (state_26715){
var state_val_26716 = (state_26715[(1)]);
if((state_val_26716 === (1))){
var state_26715__$1 = state_26715;
var statearr_26717_26831 = state_26715__$1;
(statearr_26717_26831[(2)] = null);

(statearr_26717_26831[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26716 === (2))){
var state_26715__$1 = state_26715;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26715__$1,(4),from);
} else {
if((state_val_26716 === (3))){
var inst_26713 = (state_26715[(2)]);
var state_26715__$1 = state_26715;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26715__$1,inst_26713);
} else {
if((state_val_26716 === (4))){
var inst_26696 = (state_26715[(7)]);
var inst_26696__$1 = (state_26715[(2)]);
var inst_26697 = (inst_26696__$1 == null);
var state_26715__$1 = (function (){var statearr_26718 = state_26715;
(statearr_26718[(7)] = inst_26696__$1);

return statearr_26718;
})();
if(cljs.core.truth_(inst_26697)){
var statearr_26719_26832 = state_26715__$1;
(statearr_26719_26832[(1)] = (5));

} else {
var statearr_26720_26833 = state_26715__$1;
(statearr_26720_26833[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26716 === (5))){
var inst_26699 = cljs.core.async.close_BANG_.call(null,jobs);
var state_26715__$1 = state_26715;
var statearr_26721_26834 = state_26715__$1;
(statearr_26721_26834[(2)] = inst_26699);

(statearr_26721_26834[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26716 === (6))){
var inst_26701 = (state_26715[(8)]);
var inst_26696 = (state_26715[(7)]);
var inst_26701__$1 = cljs.core.async.chan.call(null,(1));
var inst_26702 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_26703 = [inst_26696,inst_26701__$1];
var inst_26704 = (new cljs.core.PersistentVector(null,2,(5),inst_26702,inst_26703,null));
var state_26715__$1 = (function (){var statearr_26722 = state_26715;
(statearr_26722[(8)] = inst_26701__$1);

return statearr_26722;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26715__$1,(8),jobs,inst_26704);
} else {
if((state_val_26716 === (7))){
var inst_26711 = (state_26715[(2)]);
var state_26715__$1 = state_26715;
var statearr_26723_26835 = state_26715__$1;
(statearr_26723_26835[(2)] = inst_26711);

(statearr_26723_26835[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26716 === (8))){
var inst_26701 = (state_26715[(8)]);
var inst_26706 = (state_26715[(2)]);
var state_26715__$1 = (function (){var statearr_26724 = state_26715;
(statearr_26724[(9)] = inst_26706);

return statearr_26724;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26715__$1,(9),results,inst_26701);
} else {
if((state_val_26716 === (9))){
var inst_26708 = (state_26715[(2)]);
var state_26715__$1 = (function (){var statearr_26725 = state_26715;
(statearr_26725[(10)] = inst_26708);

return statearr_26725;
})();
var statearr_26726_26836 = state_26715__$1;
(statearr_26726_26836[(2)] = null);

(statearr_26726_26836[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___26830,jobs,results,process,async))
;
return ((function (switch__19660__auto__,c__19725__auto___26830,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_26730 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_26730[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__);

(statearr_26730[(1)] = (1));

return statearr_26730;
});
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1 = (function (state_26715){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26715);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26731){if((e26731 instanceof Object)){
var ex__19664__auto__ = e26731;
var statearr_26732_26837 = state_26715;
(statearr_26732_26837[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26715);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26731;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26838 = state_26715;
state_26715 = G__26838;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = function(state_26715){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1.call(this,state_26715);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___26830,jobs,results,process,async))
})();
var state__19727__auto__ = (function (){var statearr_26733 = f__19726__auto__.call(null);
(statearr_26733[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26830);

return statearr_26733;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___26830,jobs,results,process,async))
);


var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__,jobs,results,process,async){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__,jobs,results,process,async){
return (function (state_26771){
var state_val_26772 = (state_26771[(1)]);
if((state_val_26772 === (7))){
var inst_26767 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
var statearr_26773_26839 = state_26771__$1;
(statearr_26773_26839[(2)] = inst_26767);

(statearr_26773_26839[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (20))){
var state_26771__$1 = state_26771;
var statearr_26774_26840 = state_26771__$1;
(statearr_26774_26840[(2)] = null);

(statearr_26774_26840[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (1))){
var state_26771__$1 = state_26771;
var statearr_26775_26841 = state_26771__$1;
(statearr_26775_26841[(2)] = null);

(statearr_26775_26841[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (4))){
var inst_26736 = (state_26771[(7)]);
var inst_26736__$1 = (state_26771[(2)]);
var inst_26737 = (inst_26736__$1 == null);
var state_26771__$1 = (function (){var statearr_26776 = state_26771;
(statearr_26776[(7)] = inst_26736__$1);

return statearr_26776;
})();
if(cljs.core.truth_(inst_26737)){
var statearr_26777_26842 = state_26771__$1;
(statearr_26777_26842[(1)] = (5));

} else {
var statearr_26778_26843 = state_26771__$1;
(statearr_26778_26843[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (15))){
var inst_26749 = (state_26771[(8)]);
var state_26771__$1 = state_26771;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26771__$1,(18),to,inst_26749);
} else {
if((state_val_26772 === (21))){
var inst_26762 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
var statearr_26779_26844 = state_26771__$1;
(statearr_26779_26844[(2)] = inst_26762);

(statearr_26779_26844[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (13))){
var inst_26764 = (state_26771[(2)]);
var state_26771__$1 = (function (){var statearr_26780 = state_26771;
(statearr_26780[(9)] = inst_26764);

return statearr_26780;
})();
var statearr_26781_26845 = state_26771__$1;
(statearr_26781_26845[(2)] = null);

(statearr_26781_26845[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (6))){
var inst_26736 = (state_26771[(7)]);
var state_26771__$1 = state_26771;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26771__$1,(11),inst_26736);
} else {
if((state_val_26772 === (17))){
var inst_26757 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
if(cljs.core.truth_(inst_26757)){
var statearr_26782_26846 = state_26771__$1;
(statearr_26782_26846[(1)] = (19));

} else {
var statearr_26783_26847 = state_26771__$1;
(statearr_26783_26847[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (3))){
var inst_26769 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26771__$1,inst_26769);
} else {
if((state_val_26772 === (12))){
var inst_26746 = (state_26771[(10)]);
var state_26771__$1 = state_26771;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26771__$1,(14),inst_26746);
} else {
if((state_val_26772 === (2))){
var state_26771__$1 = state_26771;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26771__$1,(4),results);
} else {
if((state_val_26772 === (19))){
var state_26771__$1 = state_26771;
var statearr_26784_26848 = state_26771__$1;
(statearr_26784_26848[(2)] = null);

(statearr_26784_26848[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (11))){
var inst_26746 = (state_26771[(2)]);
var state_26771__$1 = (function (){var statearr_26785 = state_26771;
(statearr_26785[(10)] = inst_26746);

return statearr_26785;
})();
var statearr_26786_26849 = state_26771__$1;
(statearr_26786_26849[(2)] = null);

(statearr_26786_26849[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (9))){
var state_26771__$1 = state_26771;
var statearr_26787_26850 = state_26771__$1;
(statearr_26787_26850[(2)] = null);

(statearr_26787_26850[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (5))){
var state_26771__$1 = state_26771;
if(cljs.core.truth_(close_QMARK_)){
var statearr_26788_26851 = state_26771__$1;
(statearr_26788_26851[(1)] = (8));

} else {
var statearr_26789_26852 = state_26771__$1;
(statearr_26789_26852[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (14))){
var inst_26751 = (state_26771[(11)]);
var inst_26749 = (state_26771[(8)]);
var inst_26749__$1 = (state_26771[(2)]);
var inst_26750 = (inst_26749__$1 == null);
var inst_26751__$1 = cljs.core.not.call(null,inst_26750);
var state_26771__$1 = (function (){var statearr_26790 = state_26771;
(statearr_26790[(11)] = inst_26751__$1);

(statearr_26790[(8)] = inst_26749__$1);

return statearr_26790;
})();
if(inst_26751__$1){
var statearr_26791_26853 = state_26771__$1;
(statearr_26791_26853[(1)] = (15));

} else {
var statearr_26792_26854 = state_26771__$1;
(statearr_26792_26854[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (16))){
var inst_26751 = (state_26771[(11)]);
var state_26771__$1 = state_26771;
var statearr_26793_26855 = state_26771__$1;
(statearr_26793_26855[(2)] = inst_26751);

(statearr_26793_26855[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (10))){
var inst_26743 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
var statearr_26794_26856 = state_26771__$1;
(statearr_26794_26856[(2)] = inst_26743);

(statearr_26794_26856[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (18))){
var inst_26754 = (state_26771[(2)]);
var state_26771__$1 = state_26771;
var statearr_26795_26857 = state_26771__$1;
(statearr_26795_26857[(2)] = inst_26754);

(statearr_26795_26857[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26772 === (8))){
var inst_26740 = cljs.core.async.close_BANG_.call(null,to);
var state_26771__$1 = state_26771;
var statearr_26796_26858 = state_26771__$1;
(statearr_26796_26858[(2)] = inst_26740);

(statearr_26796_26858[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto__,jobs,results,process,async))
;
return ((function (switch__19660__auto__,c__19725__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_26800 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_26800[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__);

(statearr_26800[(1)] = (1));

return statearr_26800;
});
var cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1 = (function (state_26771){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26771);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26801){if((e26801 instanceof Object)){
var ex__19664__auto__ = e26801;
var statearr_26802_26859 = state_26771;
(statearr_26802_26859[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26771);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26801;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26860 = state_26771;
state_26771 = G__26860;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__ = function(state_26771){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1.call(this,state_26771);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__,jobs,results,process,async))
})();
var state__19727__auto__ = (function (){var statearr_26803 = f__19726__auto__.call(null);
(statearr_26803[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_26803;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__,jobs,results,process,async))
);

return c__19725__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args26861 = [];
var len__17454__auto___26864 = arguments.length;
var i__17455__auto___26865 = (0);
while(true){
if((i__17455__auto___26865 < len__17454__auto___26864)){
args26861.push((arguments[i__17455__auto___26865]));

var G__26866 = (i__17455__auto___26865 + (1));
i__17455__auto___26865 = G__26866;
continue;
} else {
}
break;
}

var G__26863 = args26861.length;
switch (G__26863) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26861.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args26868 = [];
var len__17454__auto___26871 = arguments.length;
var i__17455__auto___26872 = (0);
while(true){
if((i__17455__auto___26872 < len__17454__auto___26871)){
args26868.push((arguments[i__17455__auto___26872]));

var G__26873 = (i__17455__auto___26872 + (1));
i__17455__auto___26872 = G__26873;
continue;
} else {
}
break;
}

var G__26870 = args26868.length;
switch (G__26870) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26868.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;
/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args26875 = [];
var len__17454__auto___26928 = arguments.length;
var i__17455__auto___26929 = (0);
while(true){
if((i__17455__auto___26929 < len__17454__auto___26928)){
args26875.push((arguments[i__17455__auto___26929]));

var G__26930 = (i__17455__auto___26929 + (1));
i__17455__auto___26929 = G__26930;
continue;
} else {
}
break;
}

var G__26877 = args26875.length;
switch (G__26877) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26875.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__19725__auto___26932 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___26932,tc,fc){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___26932,tc,fc){
return (function (state_26903){
var state_val_26904 = (state_26903[(1)]);
if((state_val_26904 === (7))){
var inst_26899 = (state_26903[(2)]);
var state_26903__$1 = state_26903;
var statearr_26905_26933 = state_26903__$1;
(statearr_26905_26933[(2)] = inst_26899);

(statearr_26905_26933[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (1))){
var state_26903__$1 = state_26903;
var statearr_26906_26934 = state_26903__$1;
(statearr_26906_26934[(2)] = null);

(statearr_26906_26934[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (4))){
var inst_26880 = (state_26903[(7)]);
var inst_26880__$1 = (state_26903[(2)]);
var inst_26881 = (inst_26880__$1 == null);
var state_26903__$1 = (function (){var statearr_26907 = state_26903;
(statearr_26907[(7)] = inst_26880__$1);

return statearr_26907;
})();
if(cljs.core.truth_(inst_26881)){
var statearr_26908_26935 = state_26903__$1;
(statearr_26908_26935[(1)] = (5));

} else {
var statearr_26909_26936 = state_26903__$1;
(statearr_26909_26936[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (13))){
var state_26903__$1 = state_26903;
var statearr_26910_26937 = state_26903__$1;
(statearr_26910_26937[(2)] = null);

(statearr_26910_26937[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (6))){
var inst_26880 = (state_26903[(7)]);
var inst_26886 = p.call(null,inst_26880);
var state_26903__$1 = state_26903;
if(cljs.core.truth_(inst_26886)){
var statearr_26911_26938 = state_26903__$1;
(statearr_26911_26938[(1)] = (9));

} else {
var statearr_26912_26939 = state_26903__$1;
(statearr_26912_26939[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (3))){
var inst_26901 = (state_26903[(2)]);
var state_26903__$1 = state_26903;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26903__$1,inst_26901);
} else {
if((state_val_26904 === (12))){
var state_26903__$1 = state_26903;
var statearr_26913_26940 = state_26903__$1;
(statearr_26913_26940[(2)] = null);

(statearr_26913_26940[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (2))){
var state_26903__$1 = state_26903;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26903__$1,(4),ch);
} else {
if((state_val_26904 === (11))){
var inst_26880 = (state_26903[(7)]);
var inst_26890 = (state_26903[(2)]);
var state_26903__$1 = state_26903;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_26903__$1,(8),inst_26890,inst_26880);
} else {
if((state_val_26904 === (9))){
var state_26903__$1 = state_26903;
var statearr_26914_26941 = state_26903__$1;
(statearr_26914_26941[(2)] = tc);

(statearr_26914_26941[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (5))){
var inst_26883 = cljs.core.async.close_BANG_.call(null,tc);
var inst_26884 = cljs.core.async.close_BANG_.call(null,fc);
var state_26903__$1 = (function (){var statearr_26915 = state_26903;
(statearr_26915[(8)] = inst_26883);

return statearr_26915;
})();
var statearr_26916_26942 = state_26903__$1;
(statearr_26916_26942[(2)] = inst_26884);

(statearr_26916_26942[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (14))){
var inst_26897 = (state_26903[(2)]);
var state_26903__$1 = state_26903;
var statearr_26917_26943 = state_26903__$1;
(statearr_26917_26943[(2)] = inst_26897);

(statearr_26917_26943[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (10))){
var state_26903__$1 = state_26903;
var statearr_26918_26944 = state_26903__$1;
(statearr_26918_26944[(2)] = fc);

(statearr_26918_26944[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26904 === (8))){
var inst_26892 = (state_26903[(2)]);
var state_26903__$1 = state_26903;
if(cljs.core.truth_(inst_26892)){
var statearr_26919_26945 = state_26903__$1;
(statearr_26919_26945[(1)] = (12));

} else {
var statearr_26920_26946 = state_26903__$1;
(statearr_26920_26946[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___26932,tc,fc))
;
return ((function (switch__19660__auto__,c__19725__auto___26932,tc,fc){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_26924 = [null,null,null,null,null,null,null,null,null];
(statearr_26924[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_26924[(1)] = (1));

return statearr_26924;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_26903){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26903);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e26925){if((e26925 instanceof Object)){
var ex__19664__auto__ = e26925;
var statearr_26926_26947 = state_26903;
(statearr_26926_26947[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26903);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e26925;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__26948 = state_26903;
state_26903 = G__26948;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_26903){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_26903);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___26932,tc,fc))
})();
var state__19727__auto__ = (function (){var statearr_26927 = f__19726__auto__.call(null);
(statearr_26927[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___26932);

return statearr_26927;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___26932,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__){
return (function (state_26995){
var state_val_26996 = (state_26995[(1)]);
if((state_val_26996 === (1))){
var inst_26981 = init;
var state_26995__$1 = (function (){var statearr_26997 = state_26995;
(statearr_26997[(7)] = inst_26981);

return statearr_26997;
})();
var statearr_26998_27013 = state_26995__$1;
(statearr_26998_27013[(2)] = null);

(statearr_26998_27013[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26996 === (2))){
var state_26995__$1 = state_26995;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_26995__$1,(4),ch);
} else {
if((state_val_26996 === (3))){
var inst_26993 = (state_26995[(2)]);
var state_26995__$1 = state_26995;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_26995__$1,inst_26993);
} else {
if((state_val_26996 === (4))){
var inst_26984 = (state_26995[(8)]);
var inst_26984__$1 = (state_26995[(2)]);
var inst_26985 = (inst_26984__$1 == null);
var state_26995__$1 = (function (){var statearr_26999 = state_26995;
(statearr_26999[(8)] = inst_26984__$1);

return statearr_26999;
})();
if(cljs.core.truth_(inst_26985)){
var statearr_27000_27014 = state_26995__$1;
(statearr_27000_27014[(1)] = (5));

} else {
var statearr_27001_27015 = state_26995__$1;
(statearr_27001_27015[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26996 === (5))){
var inst_26981 = (state_26995[(7)]);
var state_26995__$1 = state_26995;
var statearr_27002_27016 = state_26995__$1;
(statearr_27002_27016[(2)] = inst_26981);

(statearr_27002_27016[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26996 === (6))){
var inst_26984 = (state_26995[(8)]);
var inst_26981 = (state_26995[(7)]);
var inst_26988 = f.call(null,inst_26981,inst_26984);
var inst_26981__$1 = inst_26988;
var state_26995__$1 = (function (){var statearr_27003 = state_26995;
(statearr_27003[(7)] = inst_26981__$1);

return statearr_27003;
})();
var statearr_27004_27017 = state_26995__$1;
(statearr_27004_27017[(2)] = null);

(statearr_27004_27017[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_26996 === (7))){
var inst_26991 = (state_26995[(2)]);
var state_26995__$1 = state_26995;
var statearr_27005_27018 = state_26995__$1;
(statearr_27005_27018[(2)] = inst_26991);

(statearr_27005_27018[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__19725__auto__))
;
return ((function (switch__19660__auto__,c__19725__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__19661__auto__ = null;
var cljs$core$async$reduce_$_state_machine__19661__auto____0 = (function (){
var statearr_27009 = [null,null,null,null,null,null,null,null,null];
(statearr_27009[(0)] = cljs$core$async$reduce_$_state_machine__19661__auto__);

(statearr_27009[(1)] = (1));

return statearr_27009;
});
var cljs$core$async$reduce_$_state_machine__19661__auto____1 = (function (state_26995){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_26995);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e27010){if((e27010 instanceof Object)){
var ex__19664__auto__ = e27010;
var statearr_27011_27019 = state_26995;
(statearr_27011_27019[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_26995);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27010;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27020 = state_26995;
state_26995 = G__27020;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__19661__auto__ = function(state_26995){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__19661__auto____1.call(this,state_26995);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__19661__auto____0;
cljs$core$async$reduce_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__19661__auto____1;
return cljs$core$async$reduce_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__))
})();
var state__19727__auto__ = (function (){var statearr_27012 = f__19726__auto__.call(null);
(statearr_27012[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_27012;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__))
);

return c__19725__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args27021 = [];
var len__17454__auto___27073 = arguments.length;
var i__17455__auto___27074 = (0);
while(true){
if((i__17455__auto___27074 < len__17454__auto___27073)){
args27021.push((arguments[i__17455__auto___27074]));

var G__27075 = (i__17455__auto___27074 + (1));
i__17455__auto___27074 = G__27075;
continue;
} else {
}
break;
}

var G__27023 = args27021.length;
switch (G__27023) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args27021.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__){
return (function (state_27048){
var state_val_27049 = (state_27048[(1)]);
if((state_val_27049 === (7))){
var inst_27030 = (state_27048[(2)]);
var state_27048__$1 = state_27048;
var statearr_27050_27077 = state_27048__$1;
(statearr_27050_27077[(2)] = inst_27030);

(statearr_27050_27077[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (1))){
var inst_27024 = cljs.core.seq.call(null,coll);
var inst_27025 = inst_27024;
var state_27048__$1 = (function (){var statearr_27051 = state_27048;
(statearr_27051[(7)] = inst_27025);

return statearr_27051;
})();
var statearr_27052_27078 = state_27048__$1;
(statearr_27052_27078[(2)] = null);

(statearr_27052_27078[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (4))){
var inst_27025 = (state_27048[(7)]);
var inst_27028 = cljs.core.first.call(null,inst_27025);
var state_27048__$1 = state_27048;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_27048__$1,(7),ch,inst_27028);
} else {
if((state_val_27049 === (13))){
var inst_27042 = (state_27048[(2)]);
var state_27048__$1 = state_27048;
var statearr_27053_27079 = state_27048__$1;
(statearr_27053_27079[(2)] = inst_27042);

(statearr_27053_27079[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (6))){
var inst_27033 = (state_27048[(2)]);
var state_27048__$1 = state_27048;
if(cljs.core.truth_(inst_27033)){
var statearr_27054_27080 = state_27048__$1;
(statearr_27054_27080[(1)] = (8));

} else {
var statearr_27055_27081 = state_27048__$1;
(statearr_27055_27081[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (3))){
var inst_27046 = (state_27048[(2)]);
var state_27048__$1 = state_27048;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27048__$1,inst_27046);
} else {
if((state_val_27049 === (12))){
var state_27048__$1 = state_27048;
var statearr_27056_27082 = state_27048__$1;
(statearr_27056_27082[(2)] = null);

(statearr_27056_27082[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (2))){
var inst_27025 = (state_27048[(7)]);
var state_27048__$1 = state_27048;
if(cljs.core.truth_(inst_27025)){
var statearr_27057_27083 = state_27048__$1;
(statearr_27057_27083[(1)] = (4));

} else {
var statearr_27058_27084 = state_27048__$1;
(statearr_27058_27084[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (11))){
var inst_27039 = cljs.core.async.close_BANG_.call(null,ch);
var state_27048__$1 = state_27048;
var statearr_27059_27085 = state_27048__$1;
(statearr_27059_27085[(2)] = inst_27039);

(statearr_27059_27085[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (9))){
var state_27048__$1 = state_27048;
if(cljs.core.truth_(close_QMARK_)){
var statearr_27060_27086 = state_27048__$1;
(statearr_27060_27086[(1)] = (11));

} else {
var statearr_27061_27087 = state_27048__$1;
(statearr_27061_27087[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (5))){
var inst_27025 = (state_27048[(7)]);
var state_27048__$1 = state_27048;
var statearr_27062_27088 = state_27048__$1;
(statearr_27062_27088[(2)] = inst_27025);

(statearr_27062_27088[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (10))){
var inst_27044 = (state_27048[(2)]);
var state_27048__$1 = state_27048;
var statearr_27063_27089 = state_27048__$1;
(statearr_27063_27089[(2)] = inst_27044);

(statearr_27063_27089[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27049 === (8))){
var inst_27025 = (state_27048[(7)]);
var inst_27035 = cljs.core.next.call(null,inst_27025);
var inst_27025__$1 = inst_27035;
var state_27048__$1 = (function (){var statearr_27064 = state_27048;
(statearr_27064[(7)] = inst_27025__$1);

return statearr_27064;
})();
var statearr_27065_27090 = state_27048__$1;
(statearr_27065_27090[(2)] = null);

(statearr_27065_27090[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto__))
;
return ((function (switch__19660__auto__,c__19725__auto__){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_27069 = [null,null,null,null,null,null,null,null];
(statearr_27069[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_27069[(1)] = (1));

return statearr_27069;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_27048){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_27048);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e27070){if((e27070 instanceof Object)){
var ex__19664__auto__ = e27070;
var statearr_27071_27091 = state_27048;
(statearr_27071_27091[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27048);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27070;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27092 = state_27048;
state_27048 = G__27092;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_27048){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_27048);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__))
})();
var state__19727__auto__ = (function (){var statearr_27072 = f__19726__auto__.call(null);
(statearr_27072[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_27072;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__))
);

return c__19725__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__17051__auto__ = (((_ == null))?null:_);
var m__17052__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,_);
} else {
var m__17052__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__17052__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,ch);
} else {
var m__17052__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m);
} else {
var m__17052__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async27314 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async27314 = (function (mult,ch,cs,meta27315){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta27315 = meta27315;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_27316,meta27315__$1){
var self__ = this;
var _27316__$1 = this;
return (new cljs.core.async.t_cljs$core$async27314(self__.mult,self__.ch,self__.cs,meta27315__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_27316){
var self__ = this;
var _27316__$1 = this;
return self__.meta27315;
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"mult","mult",-1187640995,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta27315","meta27315",2005722703,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async27314.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async27314.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async27314";

cljs.core.async.t_cljs$core$async27314.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async27314");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async27314 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async27314(mult__$1,ch__$1,cs__$1,meta27315){
return (new cljs.core.async.t_cljs$core$async27314(mult__$1,ch__$1,cs__$1,meta27315));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async27314(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__19725__auto___27535 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___27535,cs,m,dchan,dctr,done){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___27535,cs,m,dchan,dctr,done){
return (function (state_27447){
var state_val_27448 = (state_27447[(1)]);
if((state_val_27448 === (7))){
var inst_27443 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27449_27536 = state_27447__$1;
(statearr_27449_27536[(2)] = inst_27443);

(statearr_27449_27536[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (20))){
var inst_27348 = (state_27447[(7)]);
var inst_27358 = cljs.core.first.call(null,inst_27348);
var inst_27359 = cljs.core.nth.call(null,inst_27358,(0),null);
var inst_27360 = cljs.core.nth.call(null,inst_27358,(1),null);
var state_27447__$1 = (function (){var statearr_27450 = state_27447;
(statearr_27450[(8)] = inst_27359);

return statearr_27450;
})();
if(cljs.core.truth_(inst_27360)){
var statearr_27451_27537 = state_27447__$1;
(statearr_27451_27537[(1)] = (22));

} else {
var statearr_27452_27538 = state_27447__$1;
(statearr_27452_27538[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (27))){
var inst_27395 = (state_27447[(9)]);
var inst_27319 = (state_27447[(10)]);
var inst_27390 = (state_27447[(11)]);
var inst_27388 = (state_27447[(12)]);
var inst_27395__$1 = cljs.core._nth.call(null,inst_27388,inst_27390);
var inst_27396 = cljs.core.async.put_BANG_.call(null,inst_27395__$1,inst_27319,done);
var state_27447__$1 = (function (){var statearr_27453 = state_27447;
(statearr_27453[(9)] = inst_27395__$1);

return statearr_27453;
})();
if(cljs.core.truth_(inst_27396)){
var statearr_27454_27539 = state_27447__$1;
(statearr_27454_27539[(1)] = (30));

} else {
var statearr_27455_27540 = state_27447__$1;
(statearr_27455_27540[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (1))){
var state_27447__$1 = state_27447;
var statearr_27456_27541 = state_27447__$1;
(statearr_27456_27541[(2)] = null);

(statearr_27456_27541[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (24))){
var inst_27348 = (state_27447[(7)]);
var inst_27365 = (state_27447[(2)]);
var inst_27366 = cljs.core.next.call(null,inst_27348);
var inst_27328 = inst_27366;
var inst_27329 = null;
var inst_27330 = (0);
var inst_27331 = (0);
var state_27447__$1 = (function (){var statearr_27457 = state_27447;
(statearr_27457[(13)] = inst_27330);

(statearr_27457[(14)] = inst_27331);

(statearr_27457[(15)] = inst_27328);

(statearr_27457[(16)] = inst_27365);

(statearr_27457[(17)] = inst_27329);

return statearr_27457;
})();
var statearr_27458_27542 = state_27447__$1;
(statearr_27458_27542[(2)] = null);

(statearr_27458_27542[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (39))){
var state_27447__$1 = state_27447;
var statearr_27462_27543 = state_27447__$1;
(statearr_27462_27543[(2)] = null);

(statearr_27462_27543[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (4))){
var inst_27319 = (state_27447[(10)]);
var inst_27319__$1 = (state_27447[(2)]);
var inst_27320 = (inst_27319__$1 == null);
var state_27447__$1 = (function (){var statearr_27463 = state_27447;
(statearr_27463[(10)] = inst_27319__$1);

return statearr_27463;
})();
if(cljs.core.truth_(inst_27320)){
var statearr_27464_27544 = state_27447__$1;
(statearr_27464_27544[(1)] = (5));

} else {
var statearr_27465_27545 = state_27447__$1;
(statearr_27465_27545[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (15))){
var inst_27330 = (state_27447[(13)]);
var inst_27331 = (state_27447[(14)]);
var inst_27328 = (state_27447[(15)]);
var inst_27329 = (state_27447[(17)]);
var inst_27344 = (state_27447[(2)]);
var inst_27345 = (inst_27331 + (1));
var tmp27459 = inst_27330;
var tmp27460 = inst_27328;
var tmp27461 = inst_27329;
var inst_27328__$1 = tmp27460;
var inst_27329__$1 = tmp27461;
var inst_27330__$1 = tmp27459;
var inst_27331__$1 = inst_27345;
var state_27447__$1 = (function (){var statearr_27466 = state_27447;
(statearr_27466[(13)] = inst_27330__$1);

(statearr_27466[(14)] = inst_27331__$1);

(statearr_27466[(15)] = inst_27328__$1);

(statearr_27466[(17)] = inst_27329__$1);

(statearr_27466[(18)] = inst_27344);

return statearr_27466;
})();
var statearr_27467_27546 = state_27447__$1;
(statearr_27467_27546[(2)] = null);

(statearr_27467_27546[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (21))){
var inst_27369 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27471_27547 = state_27447__$1;
(statearr_27471_27547[(2)] = inst_27369);

(statearr_27471_27547[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (31))){
var inst_27395 = (state_27447[(9)]);
var inst_27399 = done.call(null,null);
var inst_27400 = cljs.core.async.untap_STAR_.call(null,m,inst_27395);
var state_27447__$1 = (function (){var statearr_27472 = state_27447;
(statearr_27472[(19)] = inst_27399);

return statearr_27472;
})();
var statearr_27473_27548 = state_27447__$1;
(statearr_27473_27548[(2)] = inst_27400);

(statearr_27473_27548[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (32))){
var inst_27387 = (state_27447[(20)]);
var inst_27390 = (state_27447[(11)]);
var inst_27389 = (state_27447[(21)]);
var inst_27388 = (state_27447[(12)]);
var inst_27402 = (state_27447[(2)]);
var inst_27403 = (inst_27390 + (1));
var tmp27468 = inst_27387;
var tmp27469 = inst_27389;
var tmp27470 = inst_27388;
var inst_27387__$1 = tmp27468;
var inst_27388__$1 = tmp27470;
var inst_27389__$1 = tmp27469;
var inst_27390__$1 = inst_27403;
var state_27447__$1 = (function (){var statearr_27474 = state_27447;
(statearr_27474[(22)] = inst_27402);

(statearr_27474[(20)] = inst_27387__$1);

(statearr_27474[(11)] = inst_27390__$1);

(statearr_27474[(21)] = inst_27389__$1);

(statearr_27474[(12)] = inst_27388__$1);

return statearr_27474;
})();
var statearr_27475_27549 = state_27447__$1;
(statearr_27475_27549[(2)] = null);

(statearr_27475_27549[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (40))){
var inst_27415 = (state_27447[(23)]);
var inst_27419 = done.call(null,null);
var inst_27420 = cljs.core.async.untap_STAR_.call(null,m,inst_27415);
var state_27447__$1 = (function (){var statearr_27476 = state_27447;
(statearr_27476[(24)] = inst_27419);

return statearr_27476;
})();
var statearr_27477_27550 = state_27447__$1;
(statearr_27477_27550[(2)] = inst_27420);

(statearr_27477_27550[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (33))){
var inst_27406 = (state_27447[(25)]);
var inst_27408 = cljs.core.chunked_seq_QMARK_.call(null,inst_27406);
var state_27447__$1 = state_27447;
if(inst_27408){
var statearr_27478_27551 = state_27447__$1;
(statearr_27478_27551[(1)] = (36));

} else {
var statearr_27479_27552 = state_27447__$1;
(statearr_27479_27552[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (13))){
var inst_27338 = (state_27447[(26)]);
var inst_27341 = cljs.core.async.close_BANG_.call(null,inst_27338);
var state_27447__$1 = state_27447;
var statearr_27480_27553 = state_27447__$1;
(statearr_27480_27553[(2)] = inst_27341);

(statearr_27480_27553[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (22))){
var inst_27359 = (state_27447[(8)]);
var inst_27362 = cljs.core.async.close_BANG_.call(null,inst_27359);
var state_27447__$1 = state_27447;
var statearr_27481_27554 = state_27447__$1;
(statearr_27481_27554[(2)] = inst_27362);

(statearr_27481_27554[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (36))){
var inst_27406 = (state_27447[(25)]);
var inst_27410 = cljs.core.chunk_first.call(null,inst_27406);
var inst_27411 = cljs.core.chunk_rest.call(null,inst_27406);
var inst_27412 = cljs.core.count.call(null,inst_27410);
var inst_27387 = inst_27411;
var inst_27388 = inst_27410;
var inst_27389 = inst_27412;
var inst_27390 = (0);
var state_27447__$1 = (function (){var statearr_27482 = state_27447;
(statearr_27482[(20)] = inst_27387);

(statearr_27482[(11)] = inst_27390);

(statearr_27482[(21)] = inst_27389);

(statearr_27482[(12)] = inst_27388);

return statearr_27482;
})();
var statearr_27483_27555 = state_27447__$1;
(statearr_27483_27555[(2)] = null);

(statearr_27483_27555[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (41))){
var inst_27406 = (state_27447[(25)]);
var inst_27422 = (state_27447[(2)]);
var inst_27423 = cljs.core.next.call(null,inst_27406);
var inst_27387 = inst_27423;
var inst_27388 = null;
var inst_27389 = (0);
var inst_27390 = (0);
var state_27447__$1 = (function (){var statearr_27484 = state_27447;
(statearr_27484[(27)] = inst_27422);

(statearr_27484[(20)] = inst_27387);

(statearr_27484[(11)] = inst_27390);

(statearr_27484[(21)] = inst_27389);

(statearr_27484[(12)] = inst_27388);

return statearr_27484;
})();
var statearr_27485_27556 = state_27447__$1;
(statearr_27485_27556[(2)] = null);

(statearr_27485_27556[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (43))){
var state_27447__$1 = state_27447;
var statearr_27486_27557 = state_27447__$1;
(statearr_27486_27557[(2)] = null);

(statearr_27486_27557[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (29))){
var inst_27431 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27487_27558 = state_27447__$1;
(statearr_27487_27558[(2)] = inst_27431);

(statearr_27487_27558[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (44))){
var inst_27440 = (state_27447[(2)]);
var state_27447__$1 = (function (){var statearr_27488 = state_27447;
(statearr_27488[(28)] = inst_27440);

return statearr_27488;
})();
var statearr_27489_27559 = state_27447__$1;
(statearr_27489_27559[(2)] = null);

(statearr_27489_27559[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (6))){
var inst_27379 = (state_27447[(29)]);
var inst_27378 = cljs.core.deref.call(null,cs);
var inst_27379__$1 = cljs.core.keys.call(null,inst_27378);
var inst_27380 = cljs.core.count.call(null,inst_27379__$1);
var inst_27381 = cljs.core.reset_BANG_.call(null,dctr,inst_27380);
var inst_27386 = cljs.core.seq.call(null,inst_27379__$1);
var inst_27387 = inst_27386;
var inst_27388 = null;
var inst_27389 = (0);
var inst_27390 = (0);
var state_27447__$1 = (function (){var statearr_27490 = state_27447;
(statearr_27490[(30)] = inst_27381);

(statearr_27490[(20)] = inst_27387);

(statearr_27490[(29)] = inst_27379__$1);

(statearr_27490[(11)] = inst_27390);

(statearr_27490[(21)] = inst_27389);

(statearr_27490[(12)] = inst_27388);

return statearr_27490;
})();
var statearr_27491_27560 = state_27447__$1;
(statearr_27491_27560[(2)] = null);

(statearr_27491_27560[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (28))){
var inst_27387 = (state_27447[(20)]);
var inst_27406 = (state_27447[(25)]);
var inst_27406__$1 = cljs.core.seq.call(null,inst_27387);
var state_27447__$1 = (function (){var statearr_27492 = state_27447;
(statearr_27492[(25)] = inst_27406__$1);

return statearr_27492;
})();
if(inst_27406__$1){
var statearr_27493_27561 = state_27447__$1;
(statearr_27493_27561[(1)] = (33));

} else {
var statearr_27494_27562 = state_27447__$1;
(statearr_27494_27562[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (25))){
var inst_27390 = (state_27447[(11)]);
var inst_27389 = (state_27447[(21)]);
var inst_27392 = (inst_27390 < inst_27389);
var inst_27393 = inst_27392;
var state_27447__$1 = state_27447;
if(cljs.core.truth_(inst_27393)){
var statearr_27495_27563 = state_27447__$1;
(statearr_27495_27563[(1)] = (27));

} else {
var statearr_27496_27564 = state_27447__$1;
(statearr_27496_27564[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (34))){
var state_27447__$1 = state_27447;
var statearr_27497_27565 = state_27447__$1;
(statearr_27497_27565[(2)] = null);

(statearr_27497_27565[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (17))){
var state_27447__$1 = state_27447;
var statearr_27498_27566 = state_27447__$1;
(statearr_27498_27566[(2)] = null);

(statearr_27498_27566[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (3))){
var inst_27445 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27447__$1,inst_27445);
} else {
if((state_val_27448 === (12))){
var inst_27374 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27499_27567 = state_27447__$1;
(statearr_27499_27567[(2)] = inst_27374);

(statearr_27499_27567[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (2))){
var state_27447__$1 = state_27447;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27447__$1,(4),ch);
} else {
if((state_val_27448 === (23))){
var state_27447__$1 = state_27447;
var statearr_27500_27568 = state_27447__$1;
(statearr_27500_27568[(2)] = null);

(statearr_27500_27568[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (35))){
var inst_27429 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27501_27569 = state_27447__$1;
(statearr_27501_27569[(2)] = inst_27429);

(statearr_27501_27569[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (19))){
var inst_27348 = (state_27447[(7)]);
var inst_27352 = cljs.core.chunk_first.call(null,inst_27348);
var inst_27353 = cljs.core.chunk_rest.call(null,inst_27348);
var inst_27354 = cljs.core.count.call(null,inst_27352);
var inst_27328 = inst_27353;
var inst_27329 = inst_27352;
var inst_27330 = inst_27354;
var inst_27331 = (0);
var state_27447__$1 = (function (){var statearr_27502 = state_27447;
(statearr_27502[(13)] = inst_27330);

(statearr_27502[(14)] = inst_27331);

(statearr_27502[(15)] = inst_27328);

(statearr_27502[(17)] = inst_27329);

return statearr_27502;
})();
var statearr_27503_27570 = state_27447__$1;
(statearr_27503_27570[(2)] = null);

(statearr_27503_27570[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (11))){
var inst_27328 = (state_27447[(15)]);
var inst_27348 = (state_27447[(7)]);
var inst_27348__$1 = cljs.core.seq.call(null,inst_27328);
var state_27447__$1 = (function (){var statearr_27504 = state_27447;
(statearr_27504[(7)] = inst_27348__$1);

return statearr_27504;
})();
if(inst_27348__$1){
var statearr_27505_27571 = state_27447__$1;
(statearr_27505_27571[(1)] = (16));

} else {
var statearr_27506_27572 = state_27447__$1;
(statearr_27506_27572[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (9))){
var inst_27376 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27507_27573 = state_27447__$1;
(statearr_27507_27573[(2)] = inst_27376);

(statearr_27507_27573[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (5))){
var inst_27326 = cljs.core.deref.call(null,cs);
var inst_27327 = cljs.core.seq.call(null,inst_27326);
var inst_27328 = inst_27327;
var inst_27329 = null;
var inst_27330 = (0);
var inst_27331 = (0);
var state_27447__$1 = (function (){var statearr_27508 = state_27447;
(statearr_27508[(13)] = inst_27330);

(statearr_27508[(14)] = inst_27331);

(statearr_27508[(15)] = inst_27328);

(statearr_27508[(17)] = inst_27329);

return statearr_27508;
})();
var statearr_27509_27574 = state_27447__$1;
(statearr_27509_27574[(2)] = null);

(statearr_27509_27574[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (14))){
var state_27447__$1 = state_27447;
var statearr_27510_27575 = state_27447__$1;
(statearr_27510_27575[(2)] = null);

(statearr_27510_27575[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (45))){
var inst_27437 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27511_27576 = state_27447__$1;
(statearr_27511_27576[(2)] = inst_27437);

(statearr_27511_27576[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (26))){
var inst_27379 = (state_27447[(29)]);
var inst_27433 = (state_27447[(2)]);
var inst_27434 = cljs.core.seq.call(null,inst_27379);
var state_27447__$1 = (function (){var statearr_27512 = state_27447;
(statearr_27512[(31)] = inst_27433);

return statearr_27512;
})();
if(inst_27434){
var statearr_27513_27577 = state_27447__$1;
(statearr_27513_27577[(1)] = (42));

} else {
var statearr_27514_27578 = state_27447__$1;
(statearr_27514_27578[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (16))){
var inst_27348 = (state_27447[(7)]);
var inst_27350 = cljs.core.chunked_seq_QMARK_.call(null,inst_27348);
var state_27447__$1 = state_27447;
if(inst_27350){
var statearr_27515_27579 = state_27447__$1;
(statearr_27515_27579[(1)] = (19));

} else {
var statearr_27516_27580 = state_27447__$1;
(statearr_27516_27580[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (38))){
var inst_27426 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27517_27581 = state_27447__$1;
(statearr_27517_27581[(2)] = inst_27426);

(statearr_27517_27581[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (30))){
var state_27447__$1 = state_27447;
var statearr_27518_27582 = state_27447__$1;
(statearr_27518_27582[(2)] = null);

(statearr_27518_27582[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (10))){
var inst_27331 = (state_27447[(14)]);
var inst_27329 = (state_27447[(17)]);
var inst_27337 = cljs.core._nth.call(null,inst_27329,inst_27331);
var inst_27338 = cljs.core.nth.call(null,inst_27337,(0),null);
var inst_27339 = cljs.core.nth.call(null,inst_27337,(1),null);
var state_27447__$1 = (function (){var statearr_27519 = state_27447;
(statearr_27519[(26)] = inst_27338);

return statearr_27519;
})();
if(cljs.core.truth_(inst_27339)){
var statearr_27520_27583 = state_27447__$1;
(statearr_27520_27583[(1)] = (13));

} else {
var statearr_27521_27584 = state_27447__$1;
(statearr_27521_27584[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (18))){
var inst_27372 = (state_27447[(2)]);
var state_27447__$1 = state_27447;
var statearr_27522_27585 = state_27447__$1;
(statearr_27522_27585[(2)] = inst_27372);

(statearr_27522_27585[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (42))){
var state_27447__$1 = state_27447;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27447__$1,(45),dchan);
} else {
if((state_val_27448 === (37))){
var inst_27415 = (state_27447[(23)]);
var inst_27319 = (state_27447[(10)]);
var inst_27406 = (state_27447[(25)]);
var inst_27415__$1 = cljs.core.first.call(null,inst_27406);
var inst_27416 = cljs.core.async.put_BANG_.call(null,inst_27415__$1,inst_27319,done);
var state_27447__$1 = (function (){var statearr_27523 = state_27447;
(statearr_27523[(23)] = inst_27415__$1);

return statearr_27523;
})();
if(cljs.core.truth_(inst_27416)){
var statearr_27524_27586 = state_27447__$1;
(statearr_27524_27586[(1)] = (39));

} else {
var statearr_27525_27587 = state_27447__$1;
(statearr_27525_27587[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27448 === (8))){
var inst_27330 = (state_27447[(13)]);
var inst_27331 = (state_27447[(14)]);
var inst_27333 = (inst_27331 < inst_27330);
var inst_27334 = inst_27333;
var state_27447__$1 = state_27447;
if(cljs.core.truth_(inst_27334)){
var statearr_27526_27588 = state_27447__$1;
(statearr_27526_27588[(1)] = (10));

} else {
var statearr_27527_27589 = state_27447__$1;
(statearr_27527_27589[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___27535,cs,m,dchan,dctr,done))
;
return ((function (switch__19660__auto__,c__19725__auto___27535,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__19661__auto__ = null;
var cljs$core$async$mult_$_state_machine__19661__auto____0 = (function (){
var statearr_27531 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_27531[(0)] = cljs$core$async$mult_$_state_machine__19661__auto__);

(statearr_27531[(1)] = (1));

return statearr_27531;
});
var cljs$core$async$mult_$_state_machine__19661__auto____1 = (function (state_27447){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_27447);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e27532){if((e27532 instanceof Object)){
var ex__19664__auto__ = e27532;
var statearr_27533_27590 = state_27447;
(statearr_27533_27590[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27447);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27532;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27591 = state_27447;
state_27447 = G__27591;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__19661__auto__ = function(state_27447){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__19661__auto____1.call(this,state_27447);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__19661__auto____0;
cljs$core$async$mult_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__19661__auto____1;
return cljs$core$async$mult_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___27535,cs,m,dchan,dctr,done))
})();
var state__19727__auto__ = (function (){var statearr_27534 = f__19726__auto__.call(null);
(statearr_27534[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___27535);

return statearr_27534;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___27535,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args27592 = [];
var len__17454__auto___27595 = arguments.length;
var i__17455__auto___27596 = (0);
while(true){
if((i__17455__auto___27596 < len__17454__auto___27595)){
args27592.push((arguments[i__17455__auto___27596]));

var G__27597 = (i__17455__auto___27596 + (1));
i__17455__auto___27596 = G__27597;
continue;
} else {
}
break;
}

var G__27594 = args27592.length;
switch (G__27594) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args27592.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,ch);
} else {
var m__17052__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,ch);
} else {
var m__17052__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m);
} else {
var m__17052__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,state_map);
} else {
var m__17052__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__17051__auto__ = (((m == null))?null:m);
var m__17052__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,m,mode);
} else {
var m__17052__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__17461__auto__ = [];
var len__17454__auto___27609 = arguments.length;
var i__17455__auto___27610 = (0);
while(true){
if((i__17455__auto___27610 < len__17454__auto___27609)){
args__17461__auto__.push((arguments[i__17455__auto___27610]));

var G__27611 = (i__17455__auto___27610 + (1));
i__17455__auto___27610 = G__27611;
continue;
} else {
}
break;
}

var argseq__17462__auto__ = ((((3) < args__17461__auto__.length))?(new cljs.core.IndexedSeq(args__17461__auto__.slice((3)),(0))):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__17462__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__27603){
var map__27604 = p__27603;
var map__27604__$1 = ((((!((map__27604 == null)))?((((map__27604.cljs$lang$protocol_mask$partition0$ & (64))) || (map__27604.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__27604):map__27604);
var opts = map__27604__$1;
var statearr_27606_27612 = state;
(statearr_27606_27612[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4425__auto__ = cljs.core.async.do_alts.call(null,((function (map__27604,map__27604__$1,opts){
return (function (val){
var statearr_27607_27613 = state;
(statearr_27607_27613[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__27604,map__27604__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4425__auto__)){
var cb = temp__4425__auto__;
var statearr_27608_27614 = state;
(statearr_27608_27614[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq27599){
var G__27600 = cljs.core.first.call(null,seq27599);
var seq27599__$1 = cljs.core.next.call(null,seq27599);
var G__27601 = cljs.core.first.call(null,seq27599__$1);
var seq27599__$2 = cljs.core.next.call(null,seq27599__$1);
var G__27602 = cljs.core.first.call(null,seq27599__$2);
var seq27599__$3 = cljs.core.next.call(null,seq27599__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__27600,G__27601,G__27602,seq27599__$3);
});
/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async27778 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async27778 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta27779){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta27779 = meta27779;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_27780,meta27779__$1){
var self__ = this;
var _27780__$1 = this;
return (new cljs.core.async.t_cljs$core$async27778(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta27779__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_27780){
var self__ = this;
var _27780__$1 = this;
return self__.meta27779;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),cljs.core.with_meta(new cljs.core.Symbol(null,"mix","mix",2121373763,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta27779","meta27779",1964386069,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async27778.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async27778.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async27778";

cljs.core.async.t_cljs$core$async27778.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async27778");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async27778 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async27778(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta27779){
return (new cljs.core.async.t_cljs$core$async27778(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta27779));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async27778(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__19725__auto___27941 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_27878){
var state_val_27879 = (state_27878[(1)]);
if((state_val_27879 === (7))){
var inst_27796 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
var statearr_27880_27942 = state_27878__$1;
(statearr_27880_27942[(2)] = inst_27796);

(statearr_27880_27942[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (20))){
var inst_27808 = (state_27878[(7)]);
var state_27878__$1 = state_27878;
var statearr_27881_27943 = state_27878__$1;
(statearr_27881_27943[(2)] = inst_27808);

(statearr_27881_27943[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (27))){
var state_27878__$1 = state_27878;
var statearr_27882_27944 = state_27878__$1;
(statearr_27882_27944[(2)] = null);

(statearr_27882_27944[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (1))){
var inst_27784 = (state_27878[(8)]);
var inst_27784__$1 = calc_state.call(null);
var inst_27786 = (inst_27784__$1 == null);
var inst_27787 = cljs.core.not.call(null,inst_27786);
var state_27878__$1 = (function (){var statearr_27883 = state_27878;
(statearr_27883[(8)] = inst_27784__$1);

return statearr_27883;
})();
if(inst_27787){
var statearr_27884_27945 = state_27878__$1;
(statearr_27884_27945[(1)] = (2));

} else {
var statearr_27885_27946 = state_27878__$1;
(statearr_27885_27946[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (24))){
var inst_27838 = (state_27878[(9)]);
var inst_27852 = (state_27878[(10)]);
var inst_27831 = (state_27878[(11)]);
var inst_27852__$1 = inst_27831.call(null,inst_27838);
var state_27878__$1 = (function (){var statearr_27886 = state_27878;
(statearr_27886[(10)] = inst_27852__$1);

return statearr_27886;
})();
if(cljs.core.truth_(inst_27852__$1)){
var statearr_27887_27947 = state_27878__$1;
(statearr_27887_27947[(1)] = (29));

} else {
var statearr_27888_27948 = state_27878__$1;
(statearr_27888_27948[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (4))){
var inst_27799 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27799)){
var statearr_27889_27949 = state_27878__$1;
(statearr_27889_27949[(1)] = (8));

} else {
var statearr_27890_27950 = state_27878__$1;
(statearr_27890_27950[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (15))){
var inst_27825 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27825)){
var statearr_27891_27951 = state_27878__$1;
(statearr_27891_27951[(1)] = (19));

} else {
var statearr_27892_27952 = state_27878__$1;
(statearr_27892_27952[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (21))){
var inst_27830 = (state_27878[(12)]);
var inst_27830__$1 = (state_27878[(2)]);
var inst_27831 = cljs.core.get.call(null,inst_27830__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_27832 = cljs.core.get.call(null,inst_27830__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_27833 = cljs.core.get.call(null,inst_27830__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_27878__$1 = (function (){var statearr_27893 = state_27878;
(statearr_27893[(12)] = inst_27830__$1);

(statearr_27893[(11)] = inst_27831);

(statearr_27893[(13)] = inst_27832);

return statearr_27893;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_27878__$1,(22),inst_27833);
} else {
if((state_val_27879 === (31))){
var inst_27860 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27860)){
var statearr_27894_27953 = state_27878__$1;
(statearr_27894_27953[(1)] = (32));

} else {
var statearr_27895_27954 = state_27878__$1;
(statearr_27895_27954[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (32))){
var inst_27837 = (state_27878[(14)]);
var state_27878__$1 = state_27878;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_27878__$1,(35),out,inst_27837);
} else {
if((state_val_27879 === (33))){
var inst_27830 = (state_27878[(12)]);
var inst_27808 = inst_27830;
var state_27878__$1 = (function (){var statearr_27896 = state_27878;
(statearr_27896[(7)] = inst_27808);

return statearr_27896;
})();
var statearr_27897_27955 = state_27878__$1;
(statearr_27897_27955[(2)] = null);

(statearr_27897_27955[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (13))){
var inst_27808 = (state_27878[(7)]);
var inst_27815 = inst_27808.cljs$lang$protocol_mask$partition0$;
var inst_27816 = (inst_27815 & (64));
var inst_27817 = inst_27808.cljs$core$ISeq$;
var inst_27818 = (inst_27816) || (inst_27817);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27818)){
var statearr_27898_27956 = state_27878__$1;
(statearr_27898_27956[(1)] = (16));

} else {
var statearr_27899_27957 = state_27878__$1;
(statearr_27899_27957[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (22))){
var inst_27838 = (state_27878[(9)]);
var inst_27837 = (state_27878[(14)]);
var inst_27836 = (state_27878[(2)]);
var inst_27837__$1 = cljs.core.nth.call(null,inst_27836,(0),null);
var inst_27838__$1 = cljs.core.nth.call(null,inst_27836,(1),null);
var inst_27839 = (inst_27837__$1 == null);
var inst_27840 = cljs.core._EQ_.call(null,inst_27838__$1,change);
var inst_27841 = (inst_27839) || (inst_27840);
var state_27878__$1 = (function (){var statearr_27900 = state_27878;
(statearr_27900[(9)] = inst_27838__$1);

(statearr_27900[(14)] = inst_27837__$1);

return statearr_27900;
})();
if(cljs.core.truth_(inst_27841)){
var statearr_27901_27958 = state_27878__$1;
(statearr_27901_27958[(1)] = (23));

} else {
var statearr_27902_27959 = state_27878__$1;
(statearr_27902_27959[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (36))){
var inst_27830 = (state_27878[(12)]);
var inst_27808 = inst_27830;
var state_27878__$1 = (function (){var statearr_27903 = state_27878;
(statearr_27903[(7)] = inst_27808);

return statearr_27903;
})();
var statearr_27904_27960 = state_27878__$1;
(statearr_27904_27960[(2)] = null);

(statearr_27904_27960[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (29))){
var inst_27852 = (state_27878[(10)]);
var state_27878__$1 = state_27878;
var statearr_27905_27961 = state_27878__$1;
(statearr_27905_27961[(2)] = inst_27852);

(statearr_27905_27961[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (6))){
var state_27878__$1 = state_27878;
var statearr_27906_27962 = state_27878__$1;
(statearr_27906_27962[(2)] = false);

(statearr_27906_27962[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (28))){
var inst_27848 = (state_27878[(2)]);
var inst_27849 = calc_state.call(null);
var inst_27808 = inst_27849;
var state_27878__$1 = (function (){var statearr_27907 = state_27878;
(statearr_27907[(15)] = inst_27848);

(statearr_27907[(7)] = inst_27808);

return statearr_27907;
})();
var statearr_27908_27963 = state_27878__$1;
(statearr_27908_27963[(2)] = null);

(statearr_27908_27963[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (25))){
var inst_27874 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
var statearr_27909_27964 = state_27878__$1;
(statearr_27909_27964[(2)] = inst_27874);

(statearr_27909_27964[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (34))){
var inst_27872 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
var statearr_27910_27965 = state_27878__$1;
(statearr_27910_27965[(2)] = inst_27872);

(statearr_27910_27965[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (17))){
var state_27878__$1 = state_27878;
var statearr_27911_27966 = state_27878__$1;
(statearr_27911_27966[(2)] = false);

(statearr_27911_27966[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (3))){
var state_27878__$1 = state_27878;
var statearr_27912_27967 = state_27878__$1;
(statearr_27912_27967[(2)] = false);

(statearr_27912_27967[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (12))){
var inst_27876 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27878__$1,inst_27876);
} else {
if((state_val_27879 === (2))){
var inst_27784 = (state_27878[(8)]);
var inst_27789 = inst_27784.cljs$lang$protocol_mask$partition0$;
var inst_27790 = (inst_27789 & (64));
var inst_27791 = inst_27784.cljs$core$ISeq$;
var inst_27792 = (inst_27790) || (inst_27791);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27792)){
var statearr_27913_27968 = state_27878__$1;
(statearr_27913_27968[(1)] = (5));

} else {
var statearr_27914_27969 = state_27878__$1;
(statearr_27914_27969[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (23))){
var inst_27837 = (state_27878[(14)]);
var inst_27843 = (inst_27837 == null);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27843)){
var statearr_27915_27970 = state_27878__$1;
(statearr_27915_27970[(1)] = (26));

} else {
var statearr_27916_27971 = state_27878__$1;
(statearr_27916_27971[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (35))){
var inst_27863 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
if(cljs.core.truth_(inst_27863)){
var statearr_27917_27972 = state_27878__$1;
(statearr_27917_27972[(1)] = (36));

} else {
var statearr_27918_27973 = state_27878__$1;
(statearr_27918_27973[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (19))){
var inst_27808 = (state_27878[(7)]);
var inst_27827 = cljs.core.apply.call(null,cljs.core.hash_map,inst_27808);
var state_27878__$1 = state_27878;
var statearr_27919_27974 = state_27878__$1;
(statearr_27919_27974[(2)] = inst_27827);

(statearr_27919_27974[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (11))){
var inst_27808 = (state_27878[(7)]);
var inst_27812 = (inst_27808 == null);
var inst_27813 = cljs.core.not.call(null,inst_27812);
var state_27878__$1 = state_27878;
if(inst_27813){
var statearr_27920_27975 = state_27878__$1;
(statearr_27920_27975[(1)] = (13));

} else {
var statearr_27921_27976 = state_27878__$1;
(statearr_27921_27976[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (9))){
var inst_27784 = (state_27878[(8)]);
var state_27878__$1 = state_27878;
var statearr_27922_27977 = state_27878__$1;
(statearr_27922_27977[(2)] = inst_27784);

(statearr_27922_27977[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (5))){
var state_27878__$1 = state_27878;
var statearr_27923_27978 = state_27878__$1;
(statearr_27923_27978[(2)] = true);

(statearr_27923_27978[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (14))){
var state_27878__$1 = state_27878;
var statearr_27924_27979 = state_27878__$1;
(statearr_27924_27979[(2)] = false);

(statearr_27924_27979[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (26))){
var inst_27838 = (state_27878[(9)]);
var inst_27845 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_27838);
var state_27878__$1 = state_27878;
var statearr_27925_27980 = state_27878__$1;
(statearr_27925_27980[(2)] = inst_27845);

(statearr_27925_27980[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (16))){
var state_27878__$1 = state_27878;
var statearr_27926_27981 = state_27878__$1;
(statearr_27926_27981[(2)] = true);

(statearr_27926_27981[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (38))){
var inst_27868 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
var statearr_27927_27982 = state_27878__$1;
(statearr_27927_27982[(2)] = inst_27868);

(statearr_27927_27982[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (30))){
var inst_27838 = (state_27878[(9)]);
var inst_27831 = (state_27878[(11)]);
var inst_27832 = (state_27878[(13)]);
var inst_27855 = cljs.core.empty_QMARK_.call(null,inst_27831);
var inst_27856 = inst_27832.call(null,inst_27838);
var inst_27857 = cljs.core.not.call(null,inst_27856);
var inst_27858 = (inst_27855) && (inst_27857);
var state_27878__$1 = state_27878;
var statearr_27928_27983 = state_27878__$1;
(statearr_27928_27983[(2)] = inst_27858);

(statearr_27928_27983[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (10))){
var inst_27784 = (state_27878[(8)]);
var inst_27804 = (state_27878[(2)]);
var inst_27805 = cljs.core.get.call(null,inst_27804,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_27806 = cljs.core.get.call(null,inst_27804,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_27807 = cljs.core.get.call(null,inst_27804,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_27808 = inst_27784;
var state_27878__$1 = (function (){var statearr_27929 = state_27878;
(statearr_27929[(16)] = inst_27805);

(statearr_27929[(17)] = inst_27806);

(statearr_27929[(18)] = inst_27807);

(statearr_27929[(7)] = inst_27808);

return statearr_27929;
})();
var statearr_27930_27984 = state_27878__$1;
(statearr_27930_27984[(2)] = null);

(statearr_27930_27984[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (18))){
var inst_27822 = (state_27878[(2)]);
var state_27878__$1 = state_27878;
var statearr_27931_27985 = state_27878__$1;
(statearr_27931_27985[(2)] = inst_27822);

(statearr_27931_27985[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (37))){
var state_27878__$1 = state_27878;
var statearr_27932_27986 = state_27878__$1;
(statearr_27932_27986[(2)] = null);

(statearr_27932_27986[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27879 === (8))){
var inst_27784 = (state_27878[(8)]);
var inst_27801 = cljs.core.apply.call(null,cljs.core.hash_map,inst_27784);
var state_27878__$1 = state_27878;
var statearr_27933_27987 = state_27878__$1;
(statearr_27933_27987[(2)] = inst_27801);

(statearr_27933_27987[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__19660__auto__,c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__19661__auto__ = null;
var cljs$core$async$mix_$_state_machine__19661__auto____0 = (function (){
var statearr_27937 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_27937[(0)] = cljs$core$async$mix_$_state_machine__19661__auto__);

(statearr_27937[(1)] = (1));

return statearr_27937;
});
var cljs$core$async$mix_$_state_machine__19661__auto____1 = (function (state_27878){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_27878);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e27938){if((e27938 instanceof Object)){
var ex__19664__auto__ = e27938;
var statearr_27939_27988 = state_27878;
(statearr_27939_27988[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27878);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27938;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27989 = state_27878;
state_27878 = G__27989;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__19661__auto__ = function(state_27878){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__19661__auto____1.call(this,state_27878);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__19661__auto____0;
cljs$core$async$mix_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__19661__auto____1;
return cljs$core$async$mix_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__19727__auto__ = (function (){var statearr_27940 = f__19726__auto__.call(null);
(statearr_27940[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___27941);

return statearr_27940;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___27941,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__17051__auto__ = (((p == null))?null:p);
var m__17052__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__17052__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__17051__auto__ = (((p == null))?null:p);
var m__17052__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,p,v,ch);
} else {
var m__17052__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args27990 = [];
var len__17454__auto___27993 = arguments.length;
var i__17455__auto___27994 = (0);
while(true){
if((i__17455__auto___27994 < len__17454__auto___27993)){
args27990.push((arguments[i__17455__auto___27994]));

var G__27995 = (i__17455__auto___27994 + (1));
i__17455__auto___27994 = G__27995;
continue;
} else {
}
break;
}

var G__27992 = args27990.length;
switch (G__27992) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args27990.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__17051__auto__ = (((p == null))?null:p);
var m__17052__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,p);
} else {
var m__17052__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__17051__auto__ = (((p == null))?null:p);
var m__17052__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__17051__auto__)]);
if(!((m__17052__auto__ == null))){
return m__17052__auto__.call(null,p,v);
} else {
var m__17052__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__17052__auto____$1 == null))){
return m__17052__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args27998 = [];
var len__17454__auto___28123 = arguments.length;
var i__17455__auto___28124 = (0);
while(true){
if((i__17455__auto___28124 < len__17454__auto___28123)){
args27998.push((arguments[i__17455__auto___28124]));

var G__28125 = (i__17455__auto___28124 + (1));
i__17455__auto___28124 = G__28125;
continue;
} else {
}
break;
}

var G__28000 = args27998.length;
switch (G__28000) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args27998.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__16396__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__16396__auto__)){
return or__16396__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__16396__auto__,mults){
return (function (p1__27997_SHARP_){
if(cljs.core.truth_(p1__27997_SHARP_.call(null,topic))){
return p1__27997_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__27997_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__16396__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async28001 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async28001 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta28002){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta28002 = meta28002;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_28003,meta28002__$1){
var self__ = this;
var _28003__$1 = this;
return (new cljs.core.async.t_cljs$core$async28001(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta28002__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_28003){
var self__ = this;
var _28003__$1 = this;
return self__.meta28002;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4425__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4425__auto__)){
var m = temp__4425__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta28002","meta28002",-1765801905,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async28001.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async28001.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async28001";

cljs.core.async.t_cljs$core$async28001.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async28001");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async28001 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async28001(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta28002){
return (new cljs.core.async.t_cljs$core$async28001(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta28002));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async28001(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__19725__auto___28127 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28127,mults,ensure_mult,p){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28127,mults,ensure_mult,p){
return (function (state_28075){
var state_val_28076 = (state_28075[(1)]);
if((state_val_28076 === (7))){
var inst_28071 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28077_28128 = state_28075__$1;
(statearr_28077_28128[(2)] = inst_28071);

(statearr_28077_28128[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (20))){
var state_28075__$1 = state_28075;
var statearr_28078_28129 = state_28075__$1;
(statearr_28078_28129[(2)] = null);

(statearr_28078_28129[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (1))){
var state_28075__$1 = state_28075;
var statearr_28079_28130 = state_28075__$1;
(statearr_28079_28130[(2)] = null);

(statearr_28079_28130[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (24))){
var inst_28054 = (state_28075[(7)]);
var inst_28063 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_28054);
var state_28075__$1 = state_28075;
var statearr_28080_28131 = state_28075__$1;
(statearr_28080_28131[(2)] = inst_28063);

(statearr_28080_28131[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (4))){
var inst_28006 = (state_28075[(8)]);
var inst_28006__$1 = (state_28075[(2)]);
var inst_28007 = (inst_28006__$1 == null);
var state_28075__$1 = (function (){var statearr_28081 = state_28075;
(statearr_28081[(8)] = inst_28006__$1);

return statearr_28081;
})();
if(cljs.core.truth_(inst_28007)){
var statearr_28082_28132 = state_28075__$1;
(statearr_28082_28132[(1)] = (5));

} else {
var statearr_28083_28133 = state_28075__$1;
(statearr_28083_28133[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (15))){
var inst_28048 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28084_28134 = state_28075__$1;
(statearr_28084_28134[(2)] = inst_28048);

(statearr_28084_28134[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (21))){
var inst_28068 = (state_28075[(2)]);
var state_28075__$1 = (function (){var statearr_28085 = state_28075;
(statearr_28085[(9)] = inst_28068);

return statearr_28085;
})();
var statearr_28086_28135 = state_28075__$1;
(statearr_28086_28135[(2)] = null);

(statearr_28086_28135[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (13))){
var inst_28030 = (state_28075[(10)]);
var inst_28032 = cljs.core.chunked_seq_QMARK_.call(null,inst_28030);
var state_28075__$1 = state_28075;
if(inst_28032){
var statearr_28087_28136 = state_28075__$1;
(statearr_28087_28136[(1)] = (16));

} else {
var statearr_28088_28137 = state_28075__$1;
(statearr_28088_28137[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (22))){
var inst_28060 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
if(cljs.core.truth_(inst_28060)){
var statearr_28089_28138 = state_28075__$1;
(statearr_28089_28138[(1)] = (23));

} else {
var statearr_28090_28139 = state_28075__$1;
(statearr_28090_28139[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (6))){
var inst_28006 = (state_28075[(8)]);
var inst_28054 = (state_28075[(7)]);
var inst_28056 = (state_28075[(11)]);
var inst_28054__$1 = topic_fn.call(null,inst_28006);
var inst_28055 = cljs.core.deref.call(null,mults);
var inst_28056__$1 = cljs.core.get.call(null,inst_28055,inst_28054__$1);
var state_28075__$1 = (function (){var statearr_28091 = state_28075;
(statearr_28091[(7)] = inst_28054__$1);

(statearr_28091[(11)] = inst_28056__$1);

return statearr_28091;
})();
if(cljs.core.truth_(inst_28056__$1)){
var statearr_28092_28140 = state_28075__$1;
(statearr_28092_28140[(1)] = (19));

} else {
var statearr_28093_28141 = state_28075__$1;
(statearr_28093_28141[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (25))){
var inst_28065 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28094_28142 = state_28075__$1;
(statearr_28094_28142[(2)] = inst_28065);

(statearr_28094_28142[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (17))){
var inst_28030 = (state_28075[(10)]);
var inst_28039 = cljs.core.first.call(null,inst_28030);
var inst_28040 = cljs.core.async.muxch_STAR_.call(null,inst_28039);
var inst_28041 = cljs.core.async.close_BANG_.call(null,inst_28040);
var inst_28042 = cljs.core.next.call(null,inst_28030);
var inst_28016 = inst_28042;
var inst_28017 = null;
var inst_28018 = (0);
var inst_28019 = (0);
var state_28075__$1 = (function (){var statearr_28095 = state_28075;
(statearr_28095[(12)] = inst_28018);

(statearr_28095[(13)] = inst_28019);

(statearr_28095[(14)] = inst_28041);

(statearr_28095[(15)] = inst_28017);

(statearr_28095[(16)] = inst_28016);

return statearr_28095;
})();
var statearr_28096_28143 = state_28075__$1;
(statearr_28096_28143[(2)] = null);

(statearr_28096_28143[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (3))){
var inst_28073 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28075__$1,inst_28073);
} else {
if((state_val_28076 === (12))){
var inst_28050 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28097_28144 = state_28075__$1;
(statearr_28097_28144[(2)] = inst_28050);

(statearr_28097_28144[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (2))){
var state_28075__$1 = state_28075;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28075__$1,(4),ch);
} else {
if((state_val_28076 === (23))){
var state_28075__$1 = state_28075;
var statearr_28098_28145 = state_28075__$1;
(statearr_28098_28145[(2)] = null);

(statearr_28098_28145[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (19))){
var inst_28006 = (state_28075[(8)]);
var inst_28056 = (state_28075[(11)]);
var inst_28058 = cljs.core.async.muxch_STAR_.call(null,inst_28056);
var state_28075__$1 = state_28075;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28075__$1,(22),inst_28058,inst_28006);
} else {
if((state_val_28076 === (11))){
var inst_28030 = (state_28075[(10)]);
var inst_28016 = (state_28075[(16)]);
var inst_28030__$1 = cljs.core.seq.call(null,inst_28016);
var state_28075__$1 = (function (){var statearr_28099 = state_28075;
(statearr_28099[(10)] = inst_28030__$1);

return statearr_28099;
})();
if(inst_28030__$1){
var statearr_28100_28146 = state_28075__$1;
(statearr_28100_28146[(1)] = (13));

} else {
var statearr_28101_28147 = state_28075__$1;
(statearr_28101_28147[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (9))){
var inst_28052 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28102_28148 = state_28075__$1;
(statearr_28102_28148[(2)] = inst_28052);

(statearr_28102_28148[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (5))){
var inst_28013 = cljs.core.deref.call(null,mults);
var inst_28014 = cljs.core.vals.call(null,inst_28013);
var inst_28015 = cljs.core.seq.call(null,inst_28014);
var inst_28016 = inst_28015;
var inst_28017 = null;
var inst_28018 = (0);
var inst_28019 = (0);
var state_28075__$1 = (function (){var statearr_28103 = state_28075;
(statearr_28103[(12)] = inst_28018);

(statearr_28103[(13)] = inst_28019);

(statearr_28103[(15)] = inst_28017);

(statearr_28103[(16)] = inst_28016);

return statearr_28103;
})();
var statearr_28104_28149 = state_28075__$1;
(statearr_28104_28149[(2)] = null);

(statearr_28104_28149[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (14))){
var state_28075__$1 = state_28075;
var statearr_28108_28150 = state_28075__$1;
(statearr_28108_28150[(2)] = null);

(statearr_28108_28150[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (16))){
var inst_28030 = (state_28075[(10)]);
var inst_28034 = cljs.core.chunk_first.call(null,inst_28030);
var inst_28035 = cljs.core.chunk_rest.call(null,inst_28030);
var inst_28036 = cljs.core.count.call(null,inst_28034);
var inst_28016 = inst_28035;
var inst_28017 = inst_28034;
var inst_28018 = inst_28036;
var inst_28019 = (0);
var state_28075__$1 = (function (){var statearr_28109 = state_28075;
(statearr_28109[(12)] = inst_28018);

(statearr_28109[(13)] = inst_28019);

(statearr_28109[(15)] = inst_28017);

(statearr_28109[(16)] = inst_28016);

return statearr_28109;
})();
var statearr_28110_28151 = state_28075__$1;
(statearr_28110_28151[(2)] = null);

(statearr_28110_28151[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (10))){
var inst_28018 = (state_28075[(12)]);
var inst_28019 = (state_28075[(13)]);
var inst_28017 = (state_28075[(15)]);
var inst_28016 = (state_28075[(16)]);
var inst_28024 = cljs.core._nth.call(null,inst_28017,inst_28019);
var inst_28025 = cljs.core.async.muxch_STAR_.call(null,inst_28024);
var inst_28026 = cljs.core.async.close_BANG_.call(null,inst_28025);
var inst_28027 = (inst_28019 + (1));
var tmp28105 = inst_28018;
var tmp28106 = inst_28017;
var tmp28107 = inst_28016;
var inst_28016__$1 = tmp28107;
var inst_28017__$1 = tmp28106;
var inst_28018__$1 = tmp28105;
var inst_28019__$1 = inst_28027;
var state_28075__$1 = (function (){var statearr_28111 = state_28075;
(statearr_28111[(12)] = inst_28018__$1);

(statearr_28111[(13)] = inst_28019__$1);

(statearr_28111[(15)] = inst_28017__$1);

(statearr_28111[(17)] = inst_28026);

(statearr_28111[(16)] = inst_28016__$1);

return statearr_28111;
})();
var statearr_28112_28152 = state_28075__$1;
(statearr_28112_28152[(2)] = null);

(statearr_28112_28152[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (18))){
var inst_28045 = (state_28075[(2)]);
var state_28075__$1 = state_28075;
var statearr_28113_28153 = state_28075__$1;
(statearr_28113_28153[(2)] = inst_28045);

(statearr_28113_28153[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28076 === (8))){
var inst_28018 = (state_28075[(12)]);
var inst_28019 = (state_28075[(13)]);
var inst_28021 = (inst_28019 < inst_28018);
var inst_28022 = inst_28021;
var state_28075__$1 = state_28075;
if(cljs.core.truth_(inst_28022)){
var statearr_28114_28154 = state_28075__$1;
(statearr_28114_28154[(1)] = (10));

} else {
var statearr_28115_28155 = state_28075__$1;
(statearr_28115_28155[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28127,mults,ensure_mult,p))
;
return ((function (switch__19660__auto__,c__19725__auto___28127,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28119 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28119[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28119[(1)] = (1));

return statearr_28119;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28075){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28075);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28120){if((e28120 instanceof Object)){
var ex__19664__auto__ = e28120;
var statearr_28121_28156 = state_28075;
(statearr_28121_28156[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28075);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28120;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28157 = state_28075;
state_28075 = G__28157;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28075){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28075);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28127,mults,ensure_mult,p))
})();
var state__19727__auto__ = (function (){var statearr_28122 = f__19726__auto__.call(null);
(statearr_28122[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28127);

return statearr_28122;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28127,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args28158 = [];
var len__17454__auto___28161 = arguments.length;
var i__17455__auto___28162 = (0);
while(true){
if((i__17455__auto___28162 < len__17454__auto___28161)){
args28158.push((arguments[i__17455__auto___28162]));

var G__28163 = (i__17455__auto___28162 + (1));
i__17455__auto___28162 = G__28163;
continue;
} else {
}
break;
}

var G__28160 = args28158.length;
switch (G__28160) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28158.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args28165 = [];
var len__17454__auto___28168 = arguments.length;
var i__17455__auto___28169 = (0);
while(true){
if((i__17455__auto___28169 < len__17454__auto___28168)){
args28165.push((arguments[i__17455__auto___28169]));

var G__28170 = (i__17455__auto___28169 + (1));
i__17455__auto___28169 = G__28170;
continue;
} else {
}
break;
}

var G__28167 = args28165.length;
switch (G__28167) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28165.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args28172 = [];
var len__17454__auto___28243 = arguments.length;
var i__17455__auto___28244 = (0);
while(true){
if((i__17455__auto___28244 < len__17454__auto___28243)){
args28172.push((arguments[i__17455__auto___28244]));

var G__28245 = (i__17455__auto___28244 + (1));
i__17455__auto___28244 = G__28245;
continue;
} else {
}
break;
}

var G__28174 = args28172.length;
switch (G__28174) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28172.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__19725__auto___28247 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_28213){
var state_val_28214 = (state_28213[(1)]);
if((state_val_28214 === (7))){
var state_28213__$1 = state_28213;
var statearr_28215_28248 = state_28213__$1;
(statearr_28215_28248[(2)] = null);

(statearr_28215_28248[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (1))){
var state_28213__$1 = state_28213;
var statearr_28216_28249 = state_28213__$1;
(statearr_28216_28249[(2)] = null);

(statearr_28216_28249[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (4))){
var inst_28177 = (state_28213[(7)]);
var inst_28179 = (inst_28177 < cnt);
var state_28213__$1 = state_28213;
if(cljs.core.truth_(inst_28179)){
var statearr_28217_28250 = state_28213__$1;
(statearr_28217_28250[(1)] = (6));

} else {
var statearr_28218_28251 = state_28213__$1;
(statearr_28218_28251[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (15))){
var inst_28209 = (state_28213[(2)]);
var state_28213__$1 = state_28213;
var statearr_28219_28252 = state_28213__$1;
(statearr_28219_28252[(2)] = inst_28209);

(statearr_28219_28252[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (13))){
var inst_28202 = cljs.core.async.close_BANG_.call(null,out);
var state_28213__$1 = state_28213;
var statearr_28220_28253 = state_28213__$1;
(statearr_28220_28253[(2)] = inst_28202);

(statearr_28220_28253[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (6))){
var state_28213__$1 = state_28213;
var statearr_28221_28254 = state_28213__$1;
(statearr_28221_28254[(2)] = null);

(statearr_28221_28254[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (3))){
var inst_28211 = (state_28213[(2)]);
var state_28213__$1 = state_28213;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28213__$1,inst_28211);
} else {
if((state_val_28214 === (12))){
var inst_28199 = (state_28213[(8)]);
var inst_28199__$1 = (state_28213[(2)]);
var inst_28200 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_28199__$1);
var state_28213__$1 = (function (){var statearr_28222 = state_28213;
(statearr_28222[(8)] = inst_28199__$1);

return statearr_28222;
})();
if(cljs.core.truth_(inst_28200)){
var statearr_28223_28255 = state_28213__$1;
(statearr_28223_28255[(1)] = (13));

} else {
var statearr_28224_28256 = state_28213__$1;
(statearr_28224_28256[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (2))){
var inst_28176 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_28177 = (0);
var state_28213__$1 = (function (){var statearr_28225 = state_28213;
(statearr_28225[(9)] = inst_28176);

(statearr_28225[(7)] = inst_28177);

return statearr_28225;
})();
var statearr_28226_28257 = state_28213__$1;
(statearr_28226_28257[(2)] = null);

(statearr_28226_28257[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (11))){
var inst_28177 = (state_28213[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_28213,(10),Object,null,(9));
var inst_28186 = chs__$1.call(null,inst_28177);
var inst_28187 = done.call(null,inst_28177);
var inst_28188 = cljs.core.async.take_BANG_.call(null,inst_28186,inst_28187);
var state_28213__$1 = state_28213;
var statearr_28227_28258 = state_28213__$1;
(statearr_28227_28258[(2)] = inst_28188);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28213__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (9))){
var inst_28177 = (state_28213[(7)]);
var inst_28190 = (state_28213[(2)]);
var inst_28191 = (inst_28177 + (1));
var inst_28177__$1 = inst_28191;
var state_28213__$1 = (function (){var statearr_28228 = state_28213;
(statearr_28228[(10)] = inst_28190);

(statearr_28228[(7)] = inst_28177__$1);

return statearr_28228;
})();
var statearr_28229_28259 = state_28213__$1;
(statearr_28229_28259[(2)] = null);

(statearr_28229_28259[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (5))){
var inst_28197 = (state_28213[(2)]);
var state_28213__$1 = (function (){var statearr_28230 = state_28213;
(statearr_28230[(11)] = inst_28197);

return statearr_28230;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28213__$1,(12),dchan);
} else {
if((state_val_28214 === (14))){
var inst_28199 = (state_28213[(8)]);
var inst_28204 = cljs.core.apply.call(null,f,inst_28199);
var state_28213__$1 = state_28213;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28213__$1,(16),out,inst_28204);
} else {
if((state_val_28214 === (16))){
var inst_28206 = (state_28213[(2)]);
var state_28213__$1 = (function (){var statearr_28231 = state_28213;
(statearr_28231[(12)] = inst_28206);

return statearr_28231;
})();
var statearr_28232_28260 = state_28213__$1;
(statearr_28232_28260[(2)] = null);

(statearr_28232_28260[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (10))){
var inst_28181 = (state_28213[(2)]);
var inst_28182 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_28213__$1 = (function (){var statearr_28233 = state_28213;
(statearr_28233[(13)] = inst_28181);

return statearr_28233;
})();
var statearr_28234_28261 = state_28213__$1;
(statearr_28234_28261[(2)] = inst_28182);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28213__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28214 === (8))){
var inst_28195 = (state_28213[(2)]);
var state_28213__$1 = state_28213;
var statearr_28235_28262 = state_28213__$1;
(statearr_28235_28262[(2)] = inst_28195);

(statearr_28235_28262[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__19660__auto__,c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28239 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28239[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28239[(1)] = (1));

return statearr_28239;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28213){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28213);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28240){if((e28240 instanceof Object)){
var ex__19664__auto__ = e28240;
var statearr_28241_28263 = state_28213;
(statearr_28241_28263[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28213);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28240;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28264 = state_28213;
state_28213 = G__28264;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28213){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28213);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__19727__auto__ = (function (){var statearr_28242 = f__19726__auto__.call(null);
(statearr_28242[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28247);

return statearr_28242;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28247,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args28266 = [];
var len__17454__auto___28322 = arguments.length;
var i__17455__auto___28323 = (0);
while(true){
if((i__17455__auto___28323 < len__17454__auto___28322)){
args28266.push((arguments[i__17455__auto___28323]));

var G__28324 = (i__17455__auto___28323 + (1));
i__17455__auto___28323 = G__28324;
continue;
} else {
}
break;
}

var G__28268 = args28266.length;
switch (G__28268) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28266.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28326 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28326,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28326,out){
return (function (state_28298){
var state_val_28299 = (state_28298[(1)]);
if((state_val_28299 === (7))){
var inst_28278 = (state_28298[(7)]);
var inst_28277 = (state_28298[(8)]);
var inst_28277__$1 = (state_28298[(2)]);
var inst_28278__$1 = cljs.core.nth.call(null,inst_28277__$1,(0),null);
var inst_28279 = cljs.core.nth.call(null,inst_28277__$1,(1),null);
var inst_28280 = (inst_28278__$1 == null);
var state_28298__$1 = (function (){var statearr_28300 = state_28298;
(statearr_28300[(9)] = inst_28279);

(statearr_28300[(7)] = inst_28278__$1);

(statearr_28300[(8)] = inst_28277__$1);

return statearr_28300;
})();
if(cljs.core.truth_(inst_28280)){
var statearr_28301_28327 = state_28298__$1;
(statearr_28301_28327[(1)] = (8));

} else {
var statearr_28302_28328 = state_28298__$1;
(statearr_28302_28328[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (1))){
var inst_28269 = cljs.core.vec.call(null,chs);
var inst_28270 = inst_28269;
var state_28298__$1 = (function (){var statearr_28303 = state_28298;
(statearr_28303[(10)] = inst_28270);

return statearr_28303;
})();
var statearr_28304_28329 = state_28298__$1;
(statearr_28304_28329[(2)] = null);

(statearr_28304_28329[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (4))){
var inst_28270 = (state_28298[(10)]);
var state_28298__$1 = state_28298;
return cljs.core.async.ioc_alts_BANG_.call(null,state_28298__$1,(7),inst_28270);
} else {
if((state_val_28299 === (6))){
var inst_28294 = (state_28298[(2)]);
var state_28298__$1 = state_28298;
var statearr_28305_28330 = state_28298__$1;
(statearr_28305_28330[(2)] = inst_28294);

(statearr_28305_28330[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (3))){
var inst_28296 = (state_28298[(2)]);
var state_28298__$1 = state_28298;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28298__$1,inst_28296);
} else {
if((state_val_28299 === (2))){
var inst_28270 = (state_28298[(10)]);
var inst_28272 = cljs.core.count.call(null,inst_28270);
var inst_28273 = (inst_28272 > (0));
var state_28298__$1 = state_28298;
if(cljs.core.truth_(inst_28273)){
var statearr_28307_28331 = state_28298__$1;
(statearr_28307_28331[(1)] = (4));

} else {
var statearr_28308_28332 = state_28298__$1;
(statearr_28308_28332[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (11))){
var inst_28270 = (state_28298[(10)]);
var inst_28287 = (state_28298[(2)]);
var tmp28306 = inst_28270;
var inst_28270__$1 = tmp28306;
var state_28298__$1 = (function (){var statearr_28309 = state_28298;
(statearr_28309[(11)] = inst_28287);

(statearr_28309[(10)] = inst_28270__$1);

return statearr_28309;
})();
var statearr_28310_28333 = state_28298__$1;
(statearr_28310_28333[(2)] = null);

(statearr_28310_28333[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (9))){
var inst_28278 = (state_28298[(7)]);
var state_28298__$1 = state_28298;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28298__$1,(11),out,inst_28278);
} else {
if((state_val_28299 === (5))){
var inst_28292 = cljs.core.async.close_BANG_.call(null,out);
var state_28298__$1 = state_28298;
var statearr_28311_28334 = state_28298__$1;
(statearr_28311_28334[(2)] = inst_28292);

(statearr_28311_28334[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (10))){
var inst_28290 = (state_28298[(2)]);
var state_28298__$1 = state_28298;
var statearr_28312_28335 = state_28298__$1;
(statearr_28312_28335[(2)] = inst_28290);

(statearr_28312_28335[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28299 === (8))){
var inst_28279 = (state_28298[(9)]);
var inst_28270 = (state_28298[(10)]);
var inst_28278 = (state_28298[(7)]);
var inst_28277 = (state_28298[(8)]);
var inst_28282 = (function (){var cs = inst_28270;
var vec__28275 = inst_28277;
var v = inst_28278;
var c = inst_28279;
return ((function (cs,vec__28275,v,c,inst_28279,inst_28270,inst_28278,inst_28277,state_val_28299,c__19725__auto___28326,out){
return (function (p1__28265_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__28265_SHARP_);
});
;})(cs,vec__28275,v,c,inst_28279,inst_28270,inst_28278,inst_28277,state_val_28299,c__19725__auto___28326,out))
})();
var inst_28283 = cljs.core.filterv.call(null,inst_28282,inst_28270);
var inst_28270__$1 = inst_28283;
var state_28298__$1 = (function (){var statearr_28313 = state_28298;
(statearr_28313[(10)] = inst_28270__$1);

return statearr_28313;
})();
var statearr_28314_28336 = state_28298__$1;
(statearr_28314_28336[(2)] = null);

(statearr_28314_28336[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28326,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28326,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28318 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28318[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28318[(1)] = (1));

return statearr_28318;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28298){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28298);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28319){if((e28319 instanceof Object)){
var ex__19664__auto__ = e28319;
var statearr_28320_28337 = state_28298;
(statearr_28320_28337[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28298);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28319;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28338 = state_28298;
state_28298 = G__28338;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28298){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28298);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28326,out))
})();
var state__19727__auto__ = (function (){var statearr_28321 = f__19726__auto__.call(null);
(statearr_28321[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28326);

return statearr_28321;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28326,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args28339 = [];
var len__17454__auto___28388 = arguments.length;
var i__17455__auto___28389 = (0);
while(true){
if((i__17455__auto___28389 < len__17454__auto___28388)){
args28339.push((arguments[i__17455__auto___28389]));

var G__28390 = (i__17455__auto___28389 + (1));
i__17455__auto___28389 = G__28390;
continue;
} else {
}
break;
}

var G__28341 = args28339.length;
switch (G__28341) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28339.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28392 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28392,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28392,out){
return (function (state_28365){
var state_val_28366 = (state_28365[(1)]);
if((state_val_28366 === (7))){
var inst_28347 = (state_28365[(7)]);
var inst_28347__$1 = (state_28365[(2)]);
var inst_28348 = (inst_28347__$1 == null);
var inst_28349 = cljs.core.not.call(null,inst_28348);
var state_28365__$1 = (function (){var statearr_28367 = state_28365;
(statearr_28367[(7)] = inst_28347__$1);

return statearr_28367;
})();
if(inst_28349){
var statearr_28368_28393 = state_28365__$1;
(statearr_28368_28393[(1)] = (8));

} else {
var statearr_28369_28394 = state_28365__$1;
(statearr_28369_28394[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (1))){
var inst_28342 = (0);
var state_28365__$1 = (function (){var statearr_28370 = state_28365;
(statearr_28370[(8)] = inst_28342);

return statearr_28370;
})();
var statearr_28371_28395 = state_28365__$1;
(statearr_28371_28395[(2)] = null);

(statearr_28371_28395[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (4))){
var state_28365__$1 = state_28365;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28365__$1,(7),ch);
} else {
if((state_val_28366 === (6))){
var inst_28360 = (state_28365[(2)]);
var state_28365__$1 = state_28365;
var statearr_28372_28396 = state_28365__$1;
(statearr_28372_28396[(2)] = inst_28360);

(statearr_28372_28396[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (3))){
var inst_28362 = (state_28365[(2)]);
var inst_28363 = cljs.core.async.close_BANG_.call(null,out);
var state_28365__$1 = (function (){var statearr_28373 = state_28365;
(statearr_28373[(9)] = inst_28362);

return statearr_28373;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28365__$1,inst_28363);
} else {
if((state_val_28366 === (2))){
var inst_28342 = (state_28365[(8)]);
var inst_28344 = (inst_28342 < n);
var state_28365__$1 = state_28365;
if(cljs.core.truth_(inst_28344)){
var statearr_28374_28397 = state_28365__$1;
(statearr_28374_28397[(1)] = (4));

} else {
var statearr_28375_28398 = state_28365__$1;
(statearr_28375_28398[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (11))){
var inst_28342 = (state_28365[(8)]);
var inst_28352 = (state_28365[(2)]);
var inst_28353 = (inst_28342 + (1));
var inst_28342__$1 = inst_28353;
var state_28365__$1 = (function (){var statearr_28376 = state_28365;
(statearr_28376[(8)] = inst_28342__$1);

(statearr_28376[(10)] = inst_28352);

return statearr_28376;
})();
var statearr_28377_28399 = state_28365__$1;
(statearr_28377_28399[(2)] = null);

(statearr_28377_28399[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (9))){
var state_28365__$1 = state_28365;
var statearr_28378_28400 = state_28365__$1;
(statearr_28378_28400[(2)] = null);

(statearr_28378_28400[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (5))){
var state_28365__$1 = state_28365;
var statearr_28379_28401 = state_28365__$1;
(statearr_28379_28401[(2)] = null);

(statearr_28379_28401[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (10))){
var inst_28357 = (state_28365[(2)]);
var state_28365__$1 = state_28365;
var statearr_28380_28402 = state_28365__$1;
(statearr_28380_28402[(2)] = inst_28357);

(statearr_28380_28402[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28366 === (8))){
var inst_28347 = (state_28365[(7)]);
var state_28365__$1 = state_28365;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28365__$1,(11),out,inst_28347);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28392,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28392,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28384 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_28384[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28384[(1)] = (1));

return statearr_28384;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28365){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28365);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28385){if((e28385 instanceof Object)){
var ex__19664__auto__ = e28385;
var statearr_28386_28403 = state_28365;
(statearr_28386_28403[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28365);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28385;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28404 = state_28365;
state_28365 = G__28404;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28365){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28365);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28392,out))
})();
var state__19727__auto__ = (function (){var statearr_28387 = f__19726__auto__.call(null);
(statearr_28387[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28392);

return statearr_28387;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28392,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async28412 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async28412 = (function (map_LT_,f,ch,meta28413){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta28413 = meta28413;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_28414,meta28413__$1){
var self__ = this;
var _28414__$1 = this;
return (new cljs.core.async.t_cljs$core$async28412(self__.map_LT_,self__.f,self__.ch,meta28413__$1));
});

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_28414){
var self__ = this;
var _28414__$1 = this;
return self__.meta28413;
});

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async28415 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async28415 = (function (map_LT_,f,ch,meta28413,_,fn1,meta28416){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta28413 = meta28413;
this._ = _;
this.fn1 = fn1;
this.meta28416 = meta28416;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async28415.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_28417,meta28416__$1){
var self__ = this;
var _28417__$1 = this;
return (new cljs.core.async.t_cljs$core$async28415(self__.map_LT_,self__.f,self__.ch,self__.meta28413,self__._,self__.fn1,meta28416__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async28415.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_28417){
var self__ = this;
var _28417__$1 = this;
return self__.meta28416;
});})(___$1))
;

cljs.core.async.t_cljs$core$async28415.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async28415.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async28415.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__28405_SHARP_){
return f1.call(null,(((p1__28405_SHARP_ == null))?null:self__.f.call(null,p1__28405_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async28415.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta28413","meta28413",1296679206,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async28412","cljs.core.async/t_cljs$core$async28412",-1546110970,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta28416","meta28416",422848848,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async28415.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async28415.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async28415";

cljs.core.async.t_cljs$core$async28415.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async28415");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async28415 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async28415(map_LT___$1,f__$1,ch__$1,meta28413__$1,___$2,fn1__$1,meta28416){
return (new cljs.core.async.t_cljs$core$async28415(map_LT___$1,f__$1,ch__$1,meta28413__$1,___$2,fn1__$1,meta28416));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async28415(self__.map_LT_,self__.f,self__.ch,self__.meta28413,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__16384__auto__ = ret;
if(cljs.core.truth_(and__16384__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__16384__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async28412.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async28412.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta28413","meta28413",1296679206,null)], null);
});

cljs.core.async.t_cljs$core$async28412.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async28412.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async28412";

cljs.core.async.t_cljs$core$async28412.cljs$lang$ctorPrWriter = (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async28412");
});

cljs.core.async.__GT_t_cljs$core$async28412 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async28412(map_LT___$1,f__$1,ch__$1,meta28413){
return (new cljs.core.async.t_cljs$core$async28412(map_LT___$1,f__$1,ch__$1,meta28413));
});

}

return (new cljs.core.async.t_cljs$core$async28412(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async28421 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async28421 = (function (map_GT_,f,ch,meta28422){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta28422 = meta28422;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_28423,meta28422__$1){
var self__ = this;
var _28423__$1 = this;
return (new cljs.core.async.t_cljs$core$async28421(self__.map_GT_,self__.f,self__.ch,meta28422__$1));
});

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_28423){
var self__ = this;
var _28423__$1 = this;
return self__.meta28422;
});

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async28421.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async28421.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map>","map>",1676369295,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta28422","meta28422",-1698233437,null)], null);
});

cljs.core.async.t_cljs$core$async28421.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async28421.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async28421";

cljs.core.async.t_cljs$core$async28421.cljs$lang$ctorPrWriter = (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async28421");
});

cljs.core.async.__GT_t_cljs$core$async28421 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async28421(map_GT___$1,f__$1,ch__$1,meta28422){
return (new cljs.core.async.t_cljs$core$async28421(map_GT___$1,f__$1,ch__$1,meta28422));
});

}

return (new cljs.core.async.t_cljs$core$async28421(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async28427 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async28427 = (function (filter_GT_,p,ch,meta28428){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta28428 = meta28428;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_28429,meta28428__$1){
var self__ = this;
var _28429__$1 = this;
return (new cljs.core.async.t_cljs$core$async28427(self__.filter_GT_,self__.p,self__.ch,meta28428__$1));
});

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_28429){
var self__ = this;
var _28429__$1 = this;
return self__.meta28428;
});

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async28427.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async28427.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"filter>","filter>",-37644455,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta28428","meta28428",1606882337,null)], null);
});

cljs.core.async.t_cljs$core$async28427.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async28427.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async28427";

cljs.core.async.t_cljs$core$async28427.cljs$lang$ctorPrWriter = (function (this__16994__auto__,writer__16995__auto__,opt__16996__auto__){
return cljs.core._write.call(null,writer__16995__auto__,"cljs.core.async/t_cljs$core$async28427");
});

cljs.core.async.__GT_t_cljs$core$async28427 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async28427(filter_GT___$1,p__$1,ch__$1,meta28428){
return (new cljs.core.async.t_cljs$core$async28427(filter_GT___$1,p__$1,ch__$1,meta28428));
});

}

return (new cljs.core.async.t_cljs$core$async28427(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args28430 = [];
var len__17454__auto___28474 = arguments.length;
var i__17455__auto___28475 = (0);
while(true){
if((i__17455__auto___28475 < len__17454__auto___28474)){
args28430.push((arguments[i__17455__auto___28475]));

var G__28476 = (i__17455__auto___28475 + (1));
i__17455__auto___28475 = G__28476;
continue;
} else {
}
break;
}

var G__28432 = args28430.length;
switch (G__28432) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28430.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28478 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28478,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28478,out){
return (function (state_28453){
var state_val_28454 = (state_28453[(1)]);
if((state_val_28454 === (7))){
var inst_28449 = (state_28453[(2)]);
var state_28453__$1 = state_28453;
var statearr_28455_28479 = state_28453__$1;
(statearr_28455_28479[(2)] = inst_28449);

(statearr_28455_28479[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (1))){
var state_28453__$1 = state_28453;
var statearr_28456_28480 = state_28453__$1;
(statearr_28456_28480[(2)] = null);

(statearr_28456_28480[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (4))){
var inst_28435 = (state_28453[(7)]);
var inst_28435__$1 = (state_28453[(2)]);
var inst_28436 = (inst_28435__$1 == null);
var state_28453__$1 = (function (){var statearr_28457 = state_28453;
(statearr_28457[(7)] = inst_28435__$1);

return statearr_28457;
})();
if(cljs.core.truth_(inst_28436)){
var statearr_28458_28481 = state_28453__$1;
(statearr_28458_28481[(1)] = (5));

} else {
var statearr_28459_28482 = state_28453__$1;
(statearr_28459_28482[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (6))){
var inst_28435 = (state_28453[(7)]);
var inst_28440 = p.call(null,inst_28435);
var state_28453__$1 = state_28453;
if(cljs.core.truth_(inst_28440)){
var statearr_28460_28483 = state_28453__$1;
(statearr_28460_28483[(1)] = (8));

} else {
var statearr_28461_28484 = state_28453__$1;
(statearr_28461_28484[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (3))){
var inst_28451 = (state_28453[(2)]);
var state_28453__$1 = state_28453;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28453__$1,inst_28451);
} else {
if((state_val_28454 === (2))){
var state_28453__$1 = state_28453;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28453__$1,(4),ch);
} else {
if((state_val_28454 === (11))){
var inst_28443 = (state_28453[(2)]);
var state_28453__$1 = state_28453;
var statearr_28462_28485 = state_28453__$1;
(statearr_28462_28485[(2)] = inst_28443);

(statearr_28462_28485[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (9))){
var state_28453__$1 = state_28453;
var statearr_28463_28486 = state_28453__$1;
(statearr_28463_28486[(2)] = null);

(statearr_28463_28486[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (5))){
var inst_28438 = cljs.core.async.close_BANG_.call(null,out);
var state_28453__$1 = state_28453;
var statearr_28464_28487 = state_28453__$1;
(statearr_28464_28487[(2)] = inst_28438);

(statearr_28464_28487[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (10))){
var inst_28446 = (state_28453[(2)]);
var state_28453__$1 = (function (){var statearr_28465 = state_28453;
(statearr_28465[(8)] = inst_28446);

return statearr_28465;
})();
var statearr_28466_28488 = state_28453__$1;
(statearr_28466_28488[(2)] = null);

(statearr_28466_28488[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28454 === (8))){
var inst_28435 = (state_28453[(7)]);
var state_28453__$1 = state_28453;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28453__$1,(11),out,inst_28435);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28478,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28478,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28470 = [null,null,null,null,null,null,null,null,null];
(statearr_28470[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28470[(1)] = (1));

return statearr_28470;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28453){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28453);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28471){if((e28471 instanceof Object)){
var ex__19664__auto__ = e28471;
var statearr_28472_28489 = state_28453;
(statearr_28472_28489[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28453);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28471;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28490 = state_28453;
state_28453 = G__28490;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28453){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28453);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28478,out))
})();
var state__19727__auto__ = (function (){var statearr_28473 = f__19726__auto__.call(null);
(statearr_28473[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28478);

return statearr_28473;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28478,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args28491 = [];
var len__17454__auto___28494 = arguments.length;
var i__17455__auto___28495 = (0);
while(true){
if((i__17455__auto___28495 < len__17454__auto___28494)){
args28491.push((arguments[i__17455__auto___28495]));

var G__28496 = (i__17455__auto___28495 + (1));
i__17455__auto___28495 = G__28496;
continue;
} else {
}
break;
}

var G__28493 = args28491.length;
switch (G__28493) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28491.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__){
return (function (state_28663){
var state_val_28664 = (state_28663[(1)]);
if((state_val_28664 === (7))){
var inst_28659 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
var statearr_28665_28706 = state_28663__$1;
(statearr_28665_28706[(2)] = inst_28659);

(statearr_28665_28706[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (20))){
var inst_28629 = (state_28663[(7)]);
var inst_28640 = (state_28663[(2)]);
var inst_28641 = cljs.core.next.call(null,inst_28629);
var inst_28615 = inst_28641;
var inst_28616 = null;
var inst_28617 = (0);
var inst_28618 = (0);
var state_28663__$1 = (function (){var statearr_28666 = state_28663;
(statearr_28666[(8)] = inst_28640);

(statearr_28666[(9)] = inst_28616);

(statearr_28666[(10)] = inst_28617);

(statearr_28666[(11)] = inst_28615);

(statearr_28666[(12)] = inst_28618);

return statearr_28666;
})();
var statearr_28667_28707 = state_28663__$1;
(statearr_28667_28707[(2)] = null);

(statearr_28667_28707[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (1))){
var state_28663__$1 = state_28663;
var statearr_28668_28708 = state_28663__$1;
(statearr_28668_28708[(2)] = null);

(statearr_28668_28708[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (4))){
var inst_28604 = (state_28663[(13)]);
var inst_28604__$1 = (state_28663[(2)]);
var inst_28605 = (inst_28604__$1 == null);
var state_28663__$1 = (function (){var statearr_28669 = state_28663;
(statearr_28669[(13)] = inst_28604__$1);

return statearr_28669;
})();
if(cljs.core.truth_(inst_28605)){
var statearr_28670_28709 = state_28663__$1;
(statearr_28670_28709[(1)] = (5));

} else {
var statearr_28671_28710 = state_28663__$1;
(statearr_28671_28710[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (15))){
var state_28663__$1 = state_28663;
var statearr_28675_28711 = state_28663__$1;
(statearr_28675_28711[(2)] = null);

(statearr_28675_28711[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (21))){
var state_28663__$1 = state_28663;
var statearr_28676_28712 = state_28663__$1;
(statearr_28676_28712[(2)] = null);

(statearr_28676_28712[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (13))){
var inst_28616 = (state_28663[(9)]);
var inst_28617 = (state_28663[(10)]);
var inst_28615 = (state_28663[(11)]);
var inst_28618 = (state_28663[(12)]);
var inst_28625 = (state_28663[(2)]);
var inst_28626 = (inst_28618 + (1));
var tmp28672 = inst_28616;
var tmp28673 = inst_28617;
var tmp28674 = inst_28615;
var inst_28615__$1 = tmp28674;
var inst_28616__$1 = tmp28672;
var inst_28617__$1 = tmp28673;
var inst_28618__$1 = inst_28626;
var state_28663__$1 = (function (){var statearr_28677 = state_28663;
(statearr_28677[(14)] = inst_28625);

(statearr_28677[(9)] = inst_28616__$1);

(statearr_28677[(10)] = inst_28617__$1);

(statearr_28677[(11)] = inst_28615__$1);

(statearr_28677[(12)] = inst_28618__$1);

return statearr_28677;
})();
var statearr_28678_28713 = state_28663__$1;
(statearr_28678_28713[(2)] = null);

(statearr_28678_28713[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (22))){
var state_28663__$1 = state_28663;
var statearr_28679_28714 = state_28663__$1;
(statearr_28679_28714[(2)] = null);

(statearr_28679_28714[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (6))){
var inst_28604 = (state_28663[(13)]);
var inst_28613 = f.call(null,inst_28604);
var inst_28614 = cljs.core.seq.call(null,inst_28613);
var inst_28615 = inst_28614;
var inst_28616 = null;
var inst_28617 = (0);
var inst_28618 = (0);
var state_28663__$1 = (function (){var statearr_28680 = state_28663;
(statearr_28680[(9)] = inst_28616);

(statearr_28680[(10)] = inst_28617);

(statearr_28680[(11)] = inst_28615);

(statearr_28680[(12)] = inst_28618);

return statearr_28680;
})();
var statearr_28681_28715 = state_28663__$1;
(statearr_28681_28715[(2)] = null);

(statearr_28681_28715[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (17))){
var inst_28629 = (state_28663[(7)]);
var inst_28633 = cljs.core.chunk_first.call(null,inst_28629);
var inst_28634 = cljs.core.chunk_rest.call(null,inst_28629);
var inst_28635 = cljs.core.count.call(null,inst_28633);
var inst_28615 = inst_28634;
var inst_28616 = inst_28633;
var inst_28617 = inst_28635;
var inst_28618 = (0);
var state_28663__$1 = (function (){var statearr_28682 = state_28663;
(statearr_28682[(9)] = inst_28616);

(statearr_28682[(10)] = inst_28617);

(statearr_28682[(11)] = inst_28615);

(statearr_28682[(12)] = inst_28618);

return statearr_28682;
})();
var statearr_28683_28716 = state_28663__$1;
(statearr_28683_28716[(2)] = null);

(statearr_28683_28716[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (3))){
var inst_28661 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28663__$1,inst_28661);
} else {
if((state_val_28664 === (12))){
var inst_28649 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
var statearr_28684_28717 = state_28663__$1;
(statearr_28684_28717[(2)] = inst_28649);

(statearr_28684_28717[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (2))){
var state_28663__$1 = state_28663;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28663__$1,(4),in$);
} else {
if((state_val_28664 === (23))){
var inst_28657 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
var statearr_28685_28718 = state_28663__$1;
(statearr_28685_28718[(2)] = inst_28657);

(statearr_28685_28718[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (19))){
var inst_28644 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
var statearr_28686_28719 = state_28663__$1;
(statearr_28686_28719[(2)] = inst_28644);

(statearr_28686_28719[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (11))){
var inst_28629 = (state_28663[(7)]);
var inst_28615 = (state_28663[(11)]);
var inst_28629__$1 = cljs.core.seq.call(null,inst_28615);
var state_28663__$1 = (function (){var statearr_28687 = state_28663;
(statearr_28687[(7)] = inst_28629__$1);

return statearr_28687;
})();
if(inst_28629__$1){
var statearr_28688_28720 = state_28663__$1;
(statearr_28688_28720[(1)] = (14));

} else {
var statearr_28689_28721 = state_28663__$1;
(statearr_28689_28721[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (9))){
var inst_28651 = (state_28663[(2)]);
var inst_28652 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_28663__$1 = (function (){var statearr_28690 = state_28663;
(statearr_28690[(15)] = inst_28651);

return statearr_28690;
})();
if(cljs.core.truth_(inst_28652)){
var statearr_28691_28722 = state_28663__$1;
(statearr_28691_28722[(1)] = (21));

} else {
var statearr_28692_28723 = state_28663__$1;
(statearr_28692_28723[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (5))){
var inst_28607 = cljs.core.async.close_BANG_.call(null,out);
var state_28663__$1 = state_28663;
var statearr_28693_28724 = state_28663__$1;
(statearr_28693_28724[(2)] = inst_28607);

(statearr_28693_28724[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (14))){
var inst_28629 = (state_28663[(7)]);
var inst_28631 = cljs.core.chunked_seq_QMARK_.call(null,inst_28629);
var state_28663__$1 = state_28663;
if(inst_28631){
var statearr_28694_28725 = state_28663__$1;
(statearr_28694_28725[(1)] = (17));

} else {
var statearr_28695_28726 = state_28663__$1;
(statearr_28695_28726[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (16))){
var inst_28647 = (state_28663[(2)]);
var state_28663__$1 = state_28663;
var statearr_28696_28727 = state_28663__$1;
(statearr_28696_28727[(2)] = inst_28647);

(statearr_28696_28727[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28664 === (10))){
var inst_28616 = (state_28663[(9)]);
var inst_28618 = (state_28663[(12)]);
var inst_28623 = cljs.core._nth.call(null,inst_28616,inst_28618);
var state_28663__$1 = state_28663;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28663__$1,(13),out,inst_28623);
} else {
if((state_val_28664 === (18))){
var inst_28629 = (state_28663[(7)]);
var inst_28638 = cljs.core.first.call(null,inst_28629);
var state_28663__$1 = state_28663;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28663__$1,(20),out,inst_28638);
} else {
if((state_val_28664 === (8))){
var inst_28617 = (state_28663[(10)]);
var inst_28618 = (state_28663[(12)]);
var inst_28620 = (inst_28618 < inst_28617);
var inst_28621 = inst_28620;
var state_28663__$1 = state_28663;
if(cljs.core.truth_(inst_28621)){
var statearr_28697_28728 = state_28663__$1;
(statearr_28697_28728[(1)] = (10));

} else {
var statearr_28698_28729 = state_28663__$1;
(statearr_28698_28729[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto__))
;
return ((function (switch__19660__auto__,c__19725__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____0 = (function (){
var statearr_28702 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28702[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__);

(statearr_28702[(1)] = (1));

return statearr_28702;
});
var cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____1 = (function (state_28663){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28663);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28703){if((e28703 instanceof Object)){
var ex__19664__auto__ = e28703;
var statearr_28704_28730 = state_28663;
(statearr_28704_28730[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28663);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28703;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28731 = state_28663;
state_28663 = G__28731;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__ = function(state_28663){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____1.call(this,state_28663);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__19661__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__))
})();
var state__19727__auto__ = (function (){var statearr_28705 = f__19726__auto__.call(null);
(statearr_28705[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_28705;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__))
);

return c__19725__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args28732 = [];
var len__17454__auto___28735 = arguments.length;
var i__17455__auto___28736 = (0);
while(true){
if((i__17455__auto___28736 < len__17454__auto___28735)){
args28732.push((arguments[i__17455__auto___28736]));

var G__28737 = (i__17455__auto___28736 + (1));
i__17455__auto___28736 = G__28737;
continue;
} else {
}
break;
}

var G__28734 = args28732.length;
switch (G__28734) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28732.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args28739 = [];
var len__17454__auto___28742 = arguments.length;
var i__17455__auto___28743 = (0);
while(true){
if((i__17455__auto___28743 < len__17454__auto___28742)){
args28739.push((arguments[i__17455__auto___28743]));

var G__28744 = (i__17455__auto___28743 + (1));
i__17455__auto___28743 = G__28744;
continue;
} else {
}
break;
}

var G__28741 = args28739.length;
switch (G__28741) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28739.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args28746 = [];
var len__17454__auto___28797 = arguments.length;
var i__17455__auto___28798 = (0);
while(true){
if((i__17455__auto___28798 < len__17454__auto___28797)){
args28746.push((arguments[i__17455__auto___28798]));

var G__28799 = (i__17455__auto___28798 + (1));
i__17455__auto___28798 = G__28799;
continue;
} else {
}
break;
}

var G__28748 = args28746.length;
switch (G__28748) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28746.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28801 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28801,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28801,out){
return (function (state_28772){
var state_val_28773 = (state_28772[(1)]);
if((state_val_28773 === (7))){
var inst_28767 = (state_28772[(2)]);
var state_28772__$1 = state_28772;
var statearr_28774_28802 = state_28772__$1;
(statearr_28774_28802[(2)] = inst_28767);

(statearr_28774_28802[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (1))){
var inst_28749 = null;
var state_28772__$1 = (function (){var statearr_28775 = state_28772;
(statearr_28775[(7)] = inst_28749);

return statearr_28775;
})();
var statearr_28776_28803 = state_28772__$1;
(statearr_28776_28803[(2)] = null);

(statearr_28776_28803[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (4))){
var inst_28752 = (state_28772[(8)]);
var inst_28752__$1 = (state_28772[(2)]);
var inst_28753 = (inst_28752__$1 == null);
var inst_28754 = cljs.core.not.call(null,inst_28753);
var state_28772__$1 = (function (){var statearr_28777 = state_28772;
(statearr_28777[(8)] = inst_28752__$1);

return statearr_28777;
})();
if(inst_28754){
var statearr_28778_28804 = state_28772__$1;
(statearr_28778_28804[(1)] = (5));

} else {
var statearr_28779_28805 = state_28772__$1;
(statearr_28779_28805[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (6))){
var state_28772__$1 = state_28772;
var statearr_28780_28806 = state_28772__$1;
(statearr_28780_28806[(2)] = null);

(statearr_28780_28806[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (3))){
var inst_28769 = (state_28772[(2)]);
var inst_28770 = cljs.core.async.close_BANG_.call(null,out);
var state_28772__$1 = (function (){var statearr_28781 = state_28772;
(statearr_28781[(9)] = inst_28769);

return statearr_28781;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28772__$1,inst_28770);
} else {
if((state_val_28773 === (2))){
var state_28772__$1 = state_28772;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28772__$1,(4),ch);
} else {
if((state_val_28773 === (11))){
var inst_28752 = (state_28772[(8)]);
var inst_28761 = (state_28772[(2)]);
var inst_28749 = inst_28752;
var state_28772__$1 = (function (){var statearr_28782 = state_28772;
(statearr_28782[(7)] = inst_28749);

(statearr_28782[(10)] = inst_28761);

return statearr_28782;
})();
var statearr_28783_28807 = state_28772__$1;
(statearr_28783_28807[(2)] = null);

(statearr_28783_28807[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (9))){
var inst_28752 = (state_28772[(8)]);
var state_28772__$1 = state_28772;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28772__$1,(11),out,inst_28752);
} else {
if((state_val_28773 === (5))){
var inst_28749 = (state_28772[(7)]);
var inst_28752 = (state_28772[(8)]);
var inst_28756 = cljs.core._EQ_.call(null,inst_28752,inst_28749);
var state_28772__$1 = state_28772;
if(inst_28756){
var statearr_28785_28808 = state_28772__$1;
(statearr_28785_28808[(1)] = (8));

} else {
var statearr_28786_28809 = state_28772__$1;
(statearr_28786_28809[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (10))){
var inst_28764 = (state_28772[(2)]);
var state_28772__$1 = state_28772;
var statearr_28787_28810 = state_28772__$1;
(statearr_28787_28810[(2)] = inst_28764);

(statearr_28787_28810[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28773 === (8))){
var inst_28749 = (state_28772[(7)]);
var tmp28784 = inst_28749;
var inst_28749__$1 = tmp28784;
var state_28772__$1 = (function (){var statearr_28788 = state_28772;
(statearr_28788[(7)] = inst_28749__$1);

return statearr_28788;
})();
var statearr_28789_28811 = state_28772__$1;
(statearr_28789_28811[(2)] = null);

(statearr_28789_28811[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28801,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28801,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28793 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_28793[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28793[(1)] = (1));

return statearr_28793;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28772){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28772);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28794){if((e28794 instanceof Object)){
var ex__19664__auto__ = e28794;
var statearr_28795_28812 = state_28772;
(statearr_28795_28812[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28772);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28794;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28813 = state_28772;
state_28772 = G__28813;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28772){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28772);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28801,out))
})();
var state__19727__auto__ = (function (){var statearr_28796 = f__19726__auto__.call(null);
(statearr_28796[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28801);

return statearr_28796;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28801,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args28814 = [];
var len__17454__auto___28884 = arguments.length;
var i__17455__auto___28885 = (0);
while(true){
if((i__17455__auto___28885 < len__17454__auto___28884)){
args28814.push((arguments[i__17455__auto___28885]));

var G__28886 = (i__17455__auto___28885 + (1));
i__17455__auto___28885 = G__28886;
continue;
} else {
}
break;
}

var G__28816 = args28814.length;
switch (G__28816) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28814.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28888 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28888,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28888,out){
return (function (state_28854){
var state_val_28855 = (state_28854[(1)]);
if((state_val_28855 === (7))){
var inst_28850 = (state_28854[(2)]);
var state_28854__$1 = state_28854;
var statearr_28856_28889 = state_28854__$1;
(statearr_28856_28889[(2)] = inst_28850);

(statearr_28856_28889[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (1))){
var inst_28817 = (new Array(n));
var inst_28818 = inst_28817;
var inst_28819 = (0);
var state_28854__$1 = (function (){var statearr_28857 = state_28854;
(statearr_28857[(7)] = inst_28818);

(statearr_28857[(8)] = inst_28819);

return statearr_28857;
})();
var statearr_28858_28890 = state_28854__$1;
(statearr_28858_28890[(2)] = null);

(statearr_28858_28890[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (4))){
var inst_28822 = (state_28854[(9)]);
var inst_28822__$1 = (state_28854[(2)]);
var inst_28823 = (inst_28822__$1 == null);
var inst_28824 = cljs.core.not.call(null,inst_28823);
var state_28854__$1 = (function (){var statearr_28859 = state_28854;
(statearr_28859[(9)] = inst_28822__$1);

return statearr_28859;
})();
if(inst_28824){
var statearr_28860_28891 = state_28854__$1;
(statearr_28860_28891[(1)] = (5));

} else {
var statearr_28861_28892 = state_28854__$1;
(statearr_28861_28892[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (15))){
var inst_28844 = (state_28854[(2)]);
var state_28854__$1 = state_28854;
var statearr_28862_28893 = state_28854__$1;
(statearr_28862_28893[(2)] = inst_28844);

(statearr_28862_28893[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (13))){
var state_28854__$1 = state_28854;
var statearr_28863_28894 = state_28854__$1;
(statearr_28863_28894[(2)] = null);

(statearr_28863_28894[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (6))){
var inst_28819 = (state_28854[(8)]);
var inst_28840 = (inst_28819 > (0));
var state_28854__$1 = state_28854;
if(cljs.core.truth_(inst_28840)){
var statearr_28864_28895 = state_28854__$1;
(statearr_28864_28895[(1)] = (12));

} else {
var statearr_28865_28896 = state_28854__$1;
(statearr_28865_28896[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (3))){
var inst_28852 = (state_28854[(2)]);
var state_28854__$1 = state_28854;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28854__$1,inst_28852);
} else {
if((state_val_28855 === (12))){
var inst_28818 = (state_28854[(7)]);
var inst_28842 = cljs.core.vec.call(null,inst_28818);
var state_28854__$1 = state_28854;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28854__$1,(15),out,inst_28842);
} else {
if((state_val_28855 === (2))){
var state_28854__$1 = state_28854;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28854__$1,(4),ch);
} else {
if((state_val_28855 === (11))){
var inst_28834 = (state_28854[(2)]);
var inst_28835 = (new Array(n));
var inst_28818 = inst_28835;
var inst_28819 = (0);
var state_28854__$1 = (function (){var statearr_28866 = state_28854;
(statearr_28866[(7)] = inst_28818);

(statearr_28866[(10)] = inst_28834);

(statearr_28866[(8)] = inst_28819);

return statearr_28866;
})();
var statearr_28867_28897 = state_28854__$1;
(statearr_28867_28897[(2)] = null);

(statearr_28867_28897[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (9))){
var inst_28818 = (state_28854[(7)]);
var inst_28832 = cljs.core.vec.call(null,inst_28818);
var state_28854__$1 = state_28854;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28854__$1,(11),out,inst_28832);
} else {
if((state_val_28855 === (5))){
var inst_28818 = (state_28854[(7)]);
var inst_28822 = (state_28854[(9)]);
var inst_28827 = (state_28854[(11)]);
var inst_28819 = (state_28854[(8)]);
var inst_28826 = (inst_28818[inst_28819] = inst_28822);
var inst_28827__$1 = (inst_28819 + (1));
var inst_28828 = (inst_28827__$1 < n);
var state_28854__$1 = (function (){var statearr_28868 = state_28854;
(statearr_28868[(12)] = inst_28826);

(statearr_28868[(11)] = inst_28827__$1);

return statearr_28868;
})();
if(cljs.core.truth_(inst_28828)){
var statearr_28869_28898 = state_28854__$1;
(statearr_28869_28898[(1)] = (8));

} else {
var statearr_28870_28899 = state_28854__$1;
(statearr_28870_28899[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (14))){
var inst_28847 = (state_28854[(2)]);
var inst_28848 = cljs.core.async.close_BANG_.call(null,out);
var state_28854__$1 = (function (){var statearr_28872 = state_28854;
(statearr_28872[(13)] = inst_28847);

return statearr_28872;
})();
var statearr_28873_28900 = state_28854__$1;
(statearr_28873_28900[(2)] = inst_28848);

(statearr_28873_28900[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (10))){
var inst_28838 = (state_28854[(2)]);
var state_28854__$1 = state_28854;
var statearr_28874_28901 = state_28854__$1;
(statearr_28874_28901[(2)] = inst_28838);

(statearr_28874_28901[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28855 === (8))){
var inst_28818 = (state_28854[(7)]);
var inst_28827 = (state_28854[(11)]);
var tmp28871 = inst_28818;
var inst_28818__$1 = tmp28871;
var inst_28819 = inst_28827;
var state_28854__$1 = (function (){var statearr_28875 = state_28854;
(statearr_28875[(7)] = inst_28818__$1);

(statearr_28875[(8)] = inst_28819);

return statearr_28875;
})();
var statearr_28876_28902 = state_28854__$1;
(statearr_28876_28902[(2)] = null);

(statearr_28876_28902[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28888,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28888,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28880 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28880[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28880[(1)] = (1));

return statearr_28880;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28854){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28854);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28881){if((e28881 instanceof Object)){
var ex__19664__auto__ = e28881;
var statearr_28882_28903 = state_28854;
(statearr_28882_28903[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28854);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28881;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28904 = state_28854;
state_28854 = G__28904;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28854){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28854);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28888,out))
})();
var state__19727__auto__ = (function (){var statearr_28883 = f__19726__auto__.call(null);
(statearr_28883[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28888);

return statearr_28883;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28888,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args28905 = [];
var len__17454__auto___28979 = arguments.length;
var i__17455__auto___28980 = (0);
while(true){
if((i__17455__auto___28980 < len__17454__auto___28979)){
args28905.push((arguments[i__17455__auto___28980]));

var G__28981 = (i__17455__auto___28980 + (1));
i__17455__auto___28980 = G__28981;
continue;
} else {
}
break;
}

var G__28907 = args28905.length;
switch (G__28907) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28905.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__19725__auto___28983 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___28983,out){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___28983,out){
return (function (state_28949){
var state_val_28950 = (state_28949[(1)]);
if((state_val_28950 === (7))){
var inst_28945 = (state_28949[(2)]);
var state_28949__$1 = state_28949;
var statearr_28951_28984 = state_28949__$1;
(statearr_28951_28984[(2)] = inst_28945);

(statearr_28951_28984[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (1))){
var inst_28908 = [];
var inst_28909 = inst_28908;
var inst_28910 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_28949__$1 = (function (){var statearr_28952 = state_28949;
(statearr_28952[(7)] = inst_28910);

(statearr_28952[(8)] = inst_28909);

return statearr_28952;
})();
var statearr_28953_28985 = state_28949__$1;
(statearr_28953_28985[(2)] = null);

(statearr_28953_28985[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (4))){
var inst_28913 = (state_28949[(9)]);
var inst_28913__$1 = (state_28949[(2)]);
var inst_28914 = (inst_28913__$1 == null);
var inst_28915 = cljs.core.not.call(null,inst_28914);
var state_28949__$1 = (function (){var statearr_28954 = state_28949;
(statearr_28954[(9)] = inst_28913__$1);

return statearr_28954;
})();
if(inst_28915){
var statearr_28955_28986 = state_28949__$1;
(statearr_28955_28986[(1)] = (5));

} else {
var statearr_28956_28987 = state_28949__$1;
(statearr_28956_28987[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (15))){
var inst_28939 = (state_28949[(2)]);
var state_28949__$1 = state_28949;
var statearr_28957_28988 = state_28949__$1;
(statearr_28957_28988[(2)] = inst_28939);

(statearr_28957_28988[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (13))){
var state_28949__$1 = state_28949;
var statearr_28958_28989 = state_28949__$1;
(statearr_28958_28989[(2)] = null);

(statearr_28958_28989[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (6))){
var inst_28909 = (state_28949[(8)]);
var inst_28934 = inst_28909.length;
var inst_28935 = (inst_28934 > (0));
var state_28949__$1 = state_28949;
if(cljs.core.truth_(inst_28935)){
var statearr_28959_28990 = state_28949__$1;
(statearr_28959_28990[(1)] = (12));

} else {
var statearr_28960_28991 = state_28949__$1;
(statearr_28960_28991[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (3))){
var inst_28947 = (state_28949[(2)]);
var state_28949__$1 = state_28949;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28949__$1,inst_28947);
} else {
if((state_val_28950 === (12))){
var inst_28909 = (state_28949[(8)]);
var inst_28937 = cljs.core.vec.call(null,inst_28909);
var state_28949__$1 = state_28949;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28949__$1,(15),out,inst_28937);
} else {
if((state_val_28950 === (2))){
var state_28949__$1 = state_28949;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28949__$1,(4),ch);
} else {
if((state_val_28950 === (11))){
var inst_28913 = (state_28949[(9)]);
var inst_28917 = (state_28949[(10)]);
var inst_28927 = (state_28949[(2)]);
var inst_28928 = [];
var inst_28929 = inst_28928.push(inst_28913);
var inst_28909 = inst_28928;
var inst_28910 = inst_28917;
var state_28949__$1 = (function (){var statearr_28961 = state_28949;
(statearr_28961[(11)] = inst_28929);

(statearr_28961[(12)] = inst_28927);

(statearr_28961[(7)] = inst_28910);

(statearr_28961[(8)] = inst_28909);

return statearr_28961;
})();
var statearr_28962_28992 = state_28949__$1;
(statearr_28962_28992[(2)] = null);

(statearr_28962_28992[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (9))){
var inst_28909 = (state_28949[(8)]);
var inst_28925 = cljs.core.vec.call(null,inst_28909);
var state_28949__$1 = state_28949;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_28949__$1,(11),out,inst_28925);
} else {
if((state_val_28950 === (5))){
var inst_28913 = (state_28949[(9)]);
var inst_28917 = (state_28949[(10)]);
var inst_28910 = (state_28949[(7)]);
var inst_28917__$1 = f.call(null,inst_28913);
var inst_28918 = cljs.core._EQ_.call(null,inst_28917__$1,inst_28910);
var inst_28919 = cljs.core.keyword_identical_QMARK_.call(null,inst_28910,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_28920 = (inst_28918) || (inst_28919);
var state_28949__$1 = (function (){var statearr_28963 = state_28949;
(statearr_28963[(10)] = inst_28917__$1);

return statearr_28963;
})();
if(cljs.core.truth_(inst_28920)){
var statearr_28964_28993 = state_28949__$1;
(statearr_28964_28993[(1)] = (8));

} else {
var statearr_28965_28994 = state_28949__$1;
(statearr_28965_28994[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (14))){
var inst_28942 = (state_28949[(2)]);
var inst_28943 = cljs.core.async.close_BANG_.call(null,out);
var state_28949__$1 = (function (){var statearr_28967 = state_28949;
(statearr_28967[(13)] = inst_28942);

return statearr_28967;
})();
var statearr_28968_28995 = state_28949__$1;
(statearr_28968_28995[(2)] = inst_28943);

(statearr_28968_28995[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (10))){
var inst_28932 = (state_28949[(2)]);
var state_28949__$1 = state_28949;
var statearr_28969_28996 = state_28949__$1;
(statearr_28969_28996[(2)] = inst_28932);

(statearr_28969_28996[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28950 === (8))){
var inst_28913 = (state_28949[(9)]);
var inst_28917 = (state_28949[(10)]);
var inst_28909 = (state_28949[(8)]);
var inst_28922 = inst_28909.push(inst_28913);
var tmp28966 = inst_28909;
var inst_28909__$1 = tmp28966;
var inst_28910 = inst_28917;
var state_28949__$1 = (function (){var statearr_28970 = state_28949;
(statearr_28970[(14)] = inst_28922);

(statearr_28970[(7)] = inst_28910);

(statearr_28970[(8)] = inst_28909__$1);

return statearr_28970;
})();
var statearr_28971_28997 = state_28949__$1;
(statearr_28971_28997[(2)] = null);

(statearr_28971_28997[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___28983,out))
;
return ((function (switch__19660__auto__,c__19725__auto___28983,out){
return (function() {
var cljs$core$async$state_machine__19661__auto__ = null;
var cljs$core$async$state_machine__19661__auto____0 = (function (){
var statearr_28975 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28975[(0)] = cljs$core$async$state_machine__19661__auto__);

(statearr_28975[(1)] = (1));

return statearr_28975;
});
var cljs$core$async$state_machine__19661__auto____1 = (function (state_28949){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_28949);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e28976){if((e28976 instanceof Object)){
var ex__19664__auto__ = e28976;
var statearr_28977_28998 = state_28949;
(statearr_28977_28998[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28949);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28976;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28999 = state_28949;
state_28949 = G__28999;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
cljs$core$async$state_machine__19661__auto__ = function(state_28949){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__19661__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__19661__auto____1.call(this,state_28949);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__19661__auto____0;
cljs$core$async$state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__19661__auto____1;
return cljs$core$async$state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___28983,out))
})();
var state__19727__auto__ = (function (){var statearr_28978 = f__19726__auto__.call(null);
(statearr_28978[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___28983);

return statearr_28978;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___28983,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

//# sourceMappingURL=async.js.map